// 
#include <Panzer_Battalion.h>
#include <stdio.h>
#include <iostream>
#include <cstdlib> 

using namespace std;
const Uint32 PB_MSG_LIFE = 1000000;

FILE* output;

CPanzer_Battalion :: CPanzer_Battalion(char* ip, char* outputstr)
{

 pWindowUnit = new CCpSDL("Panzer Battalion","");
 pWindowUnit->SetGameInterface(this);
 pGraphicUnit = new CCpGl();
 pWindowUnit->SetGraficInterface( (IGraphicInterface*)pGraphicUnit);
 pGraphicUnit->SetGameInterface( this );
 pThreadUnit = new CCpSDLTreader();
 pSoundUnit = new CCpSound();
 iMSGMutex = pThreadUnit->InitializeMutex();
	
 bRunning = true;
	
 CPSocketOpen();

 pThreadUnit->CreateThread( CPSocketListen, (void*) this );
 pThreadUnit->CreateThread( CPSocketListen, (void*) this );
 pThreadUnit->CreateThread( Lag, (void*) this );

 srand ( time(NULL) );

 output = fopen(outputstr,"wt");
 GameState = 0;
};

int a(void* b)
{
	((CCpGl*)b)->Draw();
   return 1;
}

void CPanzer_Battalion :: Run()
{
 
cout << "RUN" << endl;
	
//if (getip()!=0)
 CPSocketConnect(0);	
 SavedStates.time = pWindowUnit->GetTime();
 unsigned long time = pWindowUnit->GetTime();


int bla =0;
unsigned long time2,time3,time4;

//pSoundUnit->PlayMusic();

  for (int i=0;i<10;i++) SavedStates.SaveState(pGameObjectArray, pWindowUnit->GetTime());


 while( bRunning )
    {

	if (GameState	>=0)
	{
		pGraphicUnit->DrawMenu(GameState);
		 pWindowUnit->CheckMenuInput();
	}
	else
	{

		if (bla == 0)
	{
	time2 = time3;
	time3 = 0;
	}
	
	bla++;
		

       pWindowUnit->CheckInput();

	time4 = pWindowUnit->GetTime();

     unsigned long t = pWindowUnit->GetTime() - time;
	

	pGameObjectArray[72]->iGraphicObjectId=  8 + (time4%400)/34;

     for (int i = 0; i<pGameObjectArray.size()*0+2; i++)
	{
		//if (pGameObjectArray[i]->type == 1) 
			{

			SGameMsg* msg = pGameObjectArray[i]->Action(t,i);
			if (msg != NULL)
				{
				  msg[0].TimeStemp = GetTime();
				  CPSocketSend(msg);
			          this->AddMsg(msg[0]);

				  msg[1].TimeStemp = GetTime();
				  //CPSocketSend(msg+1);
			          this->AddMsg(msg[1]);
				}
			}
		}


	

		time = pWindowUnit->GetTime();

 	    this->ActOnMessages();
 	   /* if (pGameObjectArray[1]->iActive!=0) 
		 {
		   Vector3f sdir(-sinf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
 	      sinf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
	-cosf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f));

		    pGraphicUnit->SetAngles(pGameObjectArray[1]->rot.x/180.0f*3.14f,pGameObjectArray[1]->rot.y/180.0f*3.14f + 3.14f);
		    pGraphicUnit->SetPos(pGameObjectArray[1]->pos + Vector3f(0,60,0) - sdir*40 );
		 }*/

		
	     //pThreadUnit->CreateThread( a, (void*) this->pGraphicUnit);
	

		

		//pGraphicUnit->RenderLights();

		pGraphicUnit->Draw();
/*		if (bla == 10)
		{
*/	 		pGameObjectArray[1]->data[6] = 1000.0/(pWindowUnit->GetTime()-time4);	
/*			bla = 0;
		}
*/	
		// pGameObjectArray[1]->data[6] = 1000.0/(pWindowUnit->GetTime()-time4);

		time3 += pWindowUnit->GetTime()-time4;
	}
	
	
        pWindowUnit->EndCyrcle();
	


    }
    fclose(output);

};

Vector3f CPanzer_Battalion :: ACollision(Vector3f v, int oId)
{
 
 Vector3f sdir(-sinf(pGameObjectArray[oId]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[oId]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[oId]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[oId]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[oId]->rot.x/180.0f*3.14f));
 
 Vector3f s_back_right = v - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_back_left = v - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 Vector3f s_front_right = v - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_front_left = v - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 
   
 for (int i = 1; i<pGameObjectArray.size(); i++)
 if (i!=oId)
 if (pGameObjectArray[i]->iActive)
 {

	Vector3f vold = v;

  Vector3f dir(-sinf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f));
  
  Vector3f back_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f back_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  Vector3f front_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f front_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  
  Vector3f tmp;
 
  tmp = s_back_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;

  tmp = s_back_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;  
  
  tmp = s_front_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
  
  tmp = s_front_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
  
  
  tmp = back_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
  
  tmp = back_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
		
  tmp = front_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;
		
  tmp = front_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->pos;

	if ( !(v==vold) )
			{
				if (pGameObjectArray[i]->type<0)
				{
				if (pGameObjectArray[i]->type==-1)
					{
						SGameMsg msg;
						msg.type = GMSG_POWERUP_PICKED;
						msg.size = 1;
						msg.data = new float[msg.size];
						msg.data[0] = oId;
						msg.target = i;
						msg.TimeStemp = pWindowUnit->GetTime();
						this->AddMsg(msg, false);
						//if (i==1)
						//CPSocketSend(&msg);
					}
					v = vold;
				}
			}
  
 }
 
 return v;
}

float CollideWithLine(Vector3f startdot, Vector3f linedot1, Vector3f linedot2, Vector3f sdir, float distance)
	{
		 Vector3f a ,b;
                    a = startdot - linedot1;
                         b = startdot - linedot2;

                    sdir = sdir.Rescale(1);

		 if  ( ( ( ( startdot - linedot1 ).Rescale(1)).DotProduct(sdir) < 0.01 ) || ( ( ( startdot - linedot2 ).Rescale(1)).DotProduct(sdir) < 0.01 ) )
                	{
                         if ( ( a.CrossProduct(sdir).y >= -0.01 ) && ( sdir.CrossProduct(b).y >= -0.01 ) )
                               {

                                 Vector3f ab = linedot2 - linedot1;

                            float d = -ab.x*sdir.z + ab.z*sdir.x;
                            float k = -(startdot.x - linedot1.x)*sdir.z+
                                                (startdot.z - linedot1.z)*sdir.x;
                            k/=d;
                            float dist = -(startdot.x - linedot1.x)*ab.z+
                                                (startdot.z - linedot1.z)*ab.x;
                            dist /=d;

                           // if (dist < 0) dist = -dist;
                            if ( dist < distance)
                                {
					if (dist<1) dist =0;
                                    distance = dist;

                                }

                        }
			}
		return distance;

	}


Vector3f CPanzer_Battalion :: MCollision(Vector3f v, int oId)
{

	return ACollision(v,oId);

    int s = oId;


     Vector3f spdir(-sinf(pGameObjectArray[s]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[s]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[s]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[s]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[s]->rot.x/180.0f*3.14f));


  Vector3f s_back_right = pGameObjectArray[oId]->pos - ( spdir * pGameObjectArray[oId]->back ) + spdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_back_left = pGameObjectArray[oId]->pos - ( spdir * pGameObjectArray[oId]->back ) + spdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 Vector3f s_front_right = pGameObjectArray[oId]->pos - ( spdir * pGameObjectArray[oId]->front ) + spdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_front_left = pGameObjectArray[oId]->pos - ( spdir * pGameObjectArray[oId]->front ) + spdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );

    
    Vector3f sdir = (v - pGameObjectArray[oId]->pos).Rescale(1);

    float distance = (v - pGameObjectArray[oId]->pos).Length(), tmpdistance = distance;
 
   for (int i = 1; i<pGameObjectArray.size(); i++)
     if (i!=oId)
         if (pGameObjectArray[i]->iActive)
	  
         {


		
             Vector3f dir(-sinf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
                           sinf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
                       -cosf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f));
            
            Vector3f back_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f                                             (0,pGameObjectArray[i]->right,0) );
             Vector3f back_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f                                             (0,pGameObjectArray[i]->left,0) );
             Vector3f front_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f                                             (0,pGameObjectArray[i]->right,0) );
             Vector3f front_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f                                             (0,pGameObjectArray[i]->left,0) );

		//if (i!=16) pGameObjectArray[i]->iActive=0; 

            //---------------------Does s' point collide with i------------------------------------------

                   distance = CollideWithLine(s_back_left,back_right,back_left,sdir,distance);
		   distance = CollideWithLine(s_front_left,back_right,back_left,sdir,distance);
		   distance = CollideWithLine(s_back_right,back_right,back_left,sdir,distance);
		   distance = CollideWithLine(s_front_right,back_right,back_left,sdir,distance);

		   distance = CollideWithLine(s_back_left,front_left,front_right,sdir,distance);
		   distance = CollideWithLine(s_front_left,front_left,front_right,sdir,distance);
		   distance = CollideWithLine(s_back_right,front_left,front_right,sdir,distance);
		   distance = CollideWithLine(s_front_right,front_left,front_right,sdir,distance);

		   distance = CollideWithLine(s_back_left,front_right,back_right,sdir,distance);
		   distance = CollideWithLine(s_front_left,front_right,back_right,sdir,distance);
		   distance = CollideWithLine(s_back_right,front_right,back_right,sdir,distance);
		   distance = CollideWithLine(s_front_right,front_right,back_right,sdir,distance);

		   distance = CollideWithLine(s_back_left,back_left,front_left,sdir,distance);
		   distance = CollideWithLine(s_front_left,back_left,front_left,sdir,distance);
		   distance = CollideWithLine(s_back_right,back_left,front_left,sdir,distance);
		   distance = CollideWithLine(s_front_right,back_left,front_left,sdir,distance);


		   if (distance<tmpdistance)
			{
				if (pGameObjectArray[i]->type==-1)
					{
						distance=tmpdistance;
						SGameMsg msg;
						msg.type = GMSG_POWERUP_PICKED;
						msg.size = 1;
						msg.data = new float[msg.size];
						msg.data[0] = oId;
						msg.target = i;
						msg.TimeStemp = pWindowUnit->GetTime();
						this->AddMsg(msg, false);
						//if (i==1)
						//CPSocketSend(&msg);
					}else tmpdistance=distance;
			}

            //---------------------Does s' point collide with i------------------------------------------

			sdir = Vector3f(0,0,0) - sdir;

		   distance = CollideWithLine(back_left,s_back_right,s_back_left,sdir,distance);
		   distance = CollideWithLine(front_left,s_back_right,s_back_left,sdir,distance);
		   distance = CollideWithLine(back_right,s_back_right,s_back_left,sdir,distance);
		   distance = CollideWithLine(front_right,s_back_right,s_back_left,sdir,distance);

		   distance = CollideWithLine(back_left,s_front_left,s_front_right,sdir,distance);
		   distance = CollideWithLine(front_left,s_front_left,s_front_right,sdir,distance);
		   distance = CollideWithLine(back_right,s_front_left,s_front_right,sdir,distance);
		   distance = CollideWithLine(front_right,s_front_left,s_front_right,sdir,distance);

		   distance = CollideWithLine(back_left,s_front_right,s_back_right,sdir,distance);
		   distance = CollideWithLine(front_left,s_front_right,s_back_right,sdir,distance);
		   distance = CollideWithLine(back_right,s_front_right,s_back_right,sdir,distance);
		   distance = CollideWithLine(front_right,s_front_right,s_back_right,sdir,distance);

		   distance = CollideWithLine(back_left,s_back_left,s_front_left,sdir,distance);
		   distance = CollideWithLine(front_left,s_back_left,s_front_left,sdir,distance);
		   distance = CollideWithLine(back_right,s_back_left,s_front_left,sdir,distance);
		   distance = CollideWithLine(front_right,s_back_left,s_front_left,sdir,distance);

		   sdir = Vector3f(0,0,0) - sdir;


			if (distance<tmpdistance)
			{
				if (pGameObjectArray[i]->type<0)
				{
				if (pGameObjectArray[i]->type==-1)
					{
						distance=tmpdistance;
						SGameMsg msg;
						msg.type = GMSG_POWERUP_PICKED;
						msg.size = 1;
						msg.data = new float[msg.size];
						msg.data[0] = oId;
						msg.target = i;
						msg.TimeStemp = pWindowUnit->GetTime();
						this->AddMsg(msg, false);
						//if (i==1)
						//CPSocketSend(&msg);
					}
				}else tmpdistance=distance;
			}


        }
 

	
 	return pGameObjectArray[s]->pos + sdir*distance;
	
}

Vector3f CPanzer_Battalion :: RCollision(Vector3f v, int oId)
{

 Vector3f tempv = v;

 Vector3f sdir(-sinf(v.y/180.0f*3.14f)*cosf(v.x/180.0f*3.14f),
       sinf(v.x/180.0f*3.14f),
       -cosf(v.y/180.0f*3.14f)*cosf(v.x/180.0f*3.14f));
 
 Vector3f s_back_right = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_back_left = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->back ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 Vector3f s_front_right = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->right,0) );
 Vector3f s_front_left = pGameObjectArray[oId]->pos - ( sdir * pGameObjectArray[oId]->front ) + sdir.CrossProduct( Vector3f (0,pGameObjectArray[oId]->left,0) );
 
   
 for (int i = 1; i<pGameObjectArray.size(); i++)
 if (i!=oId)
 if (pGameObjectArray[i]->iActive)
 
 {
  Vector3f dir(-sinf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       sinf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
       -cosf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f));
  
  Vector3f back_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f back_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  Vector3f front_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
  Vector3f front_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
  
  Vector3f tmp;
 
  tmp = s_back_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;

  tmp = s_back_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;  
  
  tmp = s_front_right;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  tmp = s_front_left;
  if ( ( ( ( tmp-back_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-front_right ).CrossProduct(dir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-back_right ).CrossProduct(dir) ).y * ( ( tmp-back_left ).CrossProduct(dir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  
  tmp = back_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  tmp = back_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
  
  tmp = front_right;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
		
  tmp = front_left;
  if ( ( ( ( tmp-s_back_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y * ( ( tmp-s_front_right ).CrossProduct(sdir.CrossProduct(Vector3f(0,1,0))) ).y <= 0 ) &&
   ( ( ( tmp-s_back_right ).CrossProduct(sdir) ).y * ( ( tmp-s_back_left ).CrossProduct(sdir) ).y <= 0 ) )
      v = pGameObjectArray[oId]->rot;
		
		if ( !(v==tempv) )
			if (pGameObjectArray[i]->type < 0)
			{
			if (pGameObjectArray[i]->type == -1)
			{
				SGameMsg msg;
				msg.type = GMSG_POWERUP_PICKED;
				msg.size = 1;
				msg.data = new float[msg.size];
				msg.data[0] = oId;
				msg.target = i;
				msg.TimeStemp = pWindowUnit->GetTime();
				this->AddMsg(msg, false);
				//if (i==1)
				//CPSocketSend(&msg);
				
			}
			v=tempv;
			}else tempv=v;


	}
	
	return v;
}

void CPanzer_Battalion :: ActOnMessage(SGameMsg msg)
{

	if ( msg.type == GMSG_MUSIC_TOGGLE )
	{
		if ( pSoundUnit->MusicOn() )
			pSoundUnit->StopMusic(); 
		else
			pSoundUnit->PlayMusic();
		return;
	}

	if ( msg.type == GMSG_POWERUP_PICKED )
	{


		pGameObjectArray[msg.target]->iActive = 0;
		pGameObjectArray[msg.target]->iTimer = 5000;

		if (pGameObjectArray[msg.target]->data[0]==PBPT_TRAP)
			pGameObjectArray[(int)msg.data[0]]->data[PBTPD_ARMOR] = 0;
		else 
		if (pGameObjectArray[msg.target]->data[0]==PBPT_ARMOR)
		{
			pGameObjectArray[(int)msg.data[0]]->data[PBTPD_ARMOR] += 0.35;
			if (pGameObjectArray[(int)msg.data[0]]->data[PBTPD_ARMOR] >2)
				pGameObjectArray[(int)msg.data[0]]->data[PBTPD_ARMOR] = 2;
		}else
		if (pGameObjectArray[msg.target]->data[0]==PBPT_GUN)
		{
			pGameObjectArray[(int)msg.data[0]]->data[PBTPD_GUN] += 0.35;
			if (pGameObjectArray[(int)msg.data[0]]->data[PBTPD_GUN] >2)
				pGameObjectArray[(int)msg.data[0]]->data[PBTPD_GUN] = 2;
		}else
		if (pGameObjectArray[msg.target]->data[0]==PBPT_ENGINE)
		{
			pGameObjectArray[(int)msg.data[0]]->data[PBTPD_ENGINE] += 0.35;
			if (pGameObjectArray[(int)msg.data[0]]->data[PBTPD_ENGINE] >2)
				pGameObjectArray[(int)msg.data[0]]->data[PBTPD_ENGINE] = 2;
		}else
		if (pGameObjectArray[msg.target]->data[0]==PBPT_QUAD)
		{
			//cout << "aaa"<<endl;
			pGameObjectArray[(int)msg.data[0]]->color[0]=0.05;
			pGameObjectArray[(int)msg.data[0]]->color[1]=-0.5;
			pGameObjectArray[(int)msg.data[0]]->color[2]=-0.5;
			pGameObjectArray[(int)msg.data[0]]->data[9]=PBPT_QUAD;
			pGameObjectArray[(int)msg.data[0]]->data[10]= + 10000;
			
		}else
		if (pGameObjectArray[msg.target]->data[0]==PBPT_PHASE)
		{
			//cout << "aaa"<<endl;
			pGameObjectArray[(int)msg.data[0]]->color[0]=0.0;
			pGameObjectArray[(int)msg.data[0]]->color[1]=0.0;
			pGameObjectArray[(int)msg.data[0]]->color[2]=0.0;
			pGameObjectArray[(int)msg.data[0]]->data[9]=PBPT_PHASE;
			pGameObjectArray[(int)msg.data[0]]->data[10]= + 10000;
			
		}
	}

	if ( msg.type == GMSG_START_MOVE_FORWARD )
	{
		Vector3f v(-sinf(pGameObjectArray[msg.target]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[msg.target]->rot.x/180.0f*3.14f),
				   sinf(pGameObjectArray[msg.target]->rot.x/180.0f*3.14f),
				   -cosf(pGameObjectArray[msg.target]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[msg.target]->rot.x/180.0f*3.14f));
		
		pGameObjectArray[msg.target]->pos= pGameObjectArray[msg.target]->pos + ( v*
           ( (pWindowUnit->GetTime() - msg.TimeStemp )/25.0 ) );
  return;
	}
	
	if ( msg.type == 216 )
	{
		cout << msg.TimeStemp <<" "<< pWindowUnit -> GetTime()<<endl;
		return;
	}

    if ( msg.type == GMSG_DAMAGE )
	{

		pGameObjectArray[msg.target]->data[PBTPD_ENGINE] -= msg.data[0];
		if (pGameObjectArray[msg.target]->data[PBTPD_ENGINE]<0) pGameObjectArray[msg.target]->data[PBTPD_ENGINE]=0;
     		pGameObjectArray[msg.target]->data[PBTPD_ARMOR] -= msg.data[1];
		if (pGameObjectArray[msg.target]->data[PBTPD_ARMOR]<0) pGameObjectArray[msg.target]->data[PBTPD_ARMOR]=0;
     		pGameObjectArray[msg.target]->data[PBTPD_GUN] -= msg.data[2];
		if (pGameObjectArray[msg.target]->data[PBTPD_GUN]<0) pGameObjectArray[msg.target]->data[PBTPD_GUN]=0;

	
	}    

    if ( msg.type == GMSG_DEATH )
	{
	//	cout << "DEATH\n";
		pGameObjectArray[msg.target]->iActive = 0;
 	        pGameObjectArray[msg.target]->iTimer = msg.TimeStemp;
		return;
	}

     if ( msg.type == GMSG_FRAG )
	{

		if (msg.target ==1)
		{
		//cout <<"Frag!!!"<<endl; else cout << "Frag done by: " << msg.target<<endl;
		pGameObjectArray[msg.target]->data[6] += 1;
		}
		return;
	}

    if ( msg.type == GMSG_ACCELERATE )
	if (pGameObjectArray[msg.target]->iActive)
	{
                int acc_dir,acc_dir_old;

		if (pGameObjectArray[msg.target]->data[2]>0) acc_dir_old = 1; 
			else if (pGameObjectArray[msg.target]->data[2]==0) acc_dir_old = 2; 
			else acc_dir_old = 0;

		pGameObjectArray[msg.target]->data[2] += msg.data[0]*(pGameObjectArray[msg.target]->data[PBTPD_ENGINE]/5.0f +0.8f);

		if (pGameObjectArray[msg.target]->data[2]>1.0) pGameObjectArray[msg.target]->data[2] = 1.0;
		if (pGameObjectArray[msg.target]->data[2]<-1.0) pGameObjectArray[msg.target]->data[2] = -1.0;

                if (pGameObjectArray[msg.target]->data[2]>0) acc_dir = 1; else acc_dir = 0;

		if ((acc_dir!=acc_dir_old)&&(acc_dir_old!=2)) pGameObjectArray[msg.target]->data[2] = 0.0;
		
		return;
	}
	
    if ( msg.type == GMSG_MOVE_TO_LOC )
	if (pGameObjectArray[msg.target]->iActive)
	{
		
		Vector3f v(msg.data[0],msg.data[1],msg.data[2]);
		
		v = MCollision(v,msg.target);
		
		pGameObjectArray[msg.target]->pos=v;

		//cout <<"target:"<< msg.target<<endl;
		return;
	}
	
	if ( msg.type == GMSG_CHANGE_ANGLES )
	 if (pGameObjectArray[msg.target]->iActive)
	{
		Vector3f v(msg.data[0],msg.data[1],0);
		pGameObjectArray[msg.target]->rot = RCollision(v,msg.target);
		return;
	}
	
	if ( msg.type == GMSG_SHOOT )
	{
		
		int index = -1;
		float distance = 100000.0;
		int s = msg.target;

		if (msg.TimeStemp - pGameObjectArray[msg.target]->iTimer > 2500 + 1000*(-1 - pGameObjectArray[msg.target]->data[PBTPD_GUN]/2))
		{

			pGameObjectArray[s]->data[7] = -1; 
			pGameObjectArray[s]->data[8] = -1;

			if (pGameObjectArray[msg.target]->iActive == true)
			{
				pGameObjectArray[msg.target]->iTimer = msg.TimeStemp;
				if (msg.target==1)
					{

						pSoundUnit->PlaySound(0,100);
//---------------------------------------move a bit to the back-----------------------------------------
						Vector3f dir(-sinf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
				 	        sinf(pGameObjectArray[1]->rot.x/180.0f*3.14f),
						-cosf(pGameObjectArray[1]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[1]->rot.x/180.0f*3.14f));

			
		  				Vector3f pos = pGameObjectArray[1]->pos - dir;
						SGameMsg msg;
						msg.type = GMSG_MOVE_TO_LOC;
						msg.target = 1;
						msg.size = 3;
						msg.data = new float[3];
						msg.data[0] = pos.x;
						msg.data[1] = pos.y;
						msg.data[2] = pos.z;
						msg.TimeStemp = GetTime();
						CPSocketSend(&msg);
						MsgArray.push_back(msg);
//-------------------------------------move a bit to the back(done)-------------------------------------
					}//if (msg.target==1)
				int i = 1;
				for (i=1;i<pGameObjectArray.size();i++)
				if ( ( i != msg.target ) && ( pGameObjectArray[i]->iActive ) && (pGameObjectArray[i]->type >= 0) )
				{

					
					Vector3f sdir(-sinf(pGameObjectArray[s]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[s]->rot.x/180.0f*3.14f),
				        sinf(pGameObjectArray[s]->rot.x/180.0f*3.14f),
				         -cosf(pGameObjectArray[s]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[s]->rot.x/180.0f*3.14f));


					Vector3f dir(-sinf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
				        sinf(pGameObjectArray[i]->rot.x/180.0f*3.14f),
				        -cosf(pGameObjectArray[i]->rot.y/180.0f*3.14f)*cosf(pGameObjectArray[i]->rot.x/180.0f*3.14f));

					Vector3f back_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
     					Vector3f back_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->back ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );
     					Vector3f front_right = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->right,0) );
     					Vector3f front_left = pGameObjectArray[i]->pos - ( dir * pGameObjectArray[i]->front ) + dir.CrossProduct( Vector3f (0,pGameObjectArray[i]->left,0) );

					 /*if ( ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y * ((back_left - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y <= 0 )  ||
      ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y * ((front_right - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y <= 0 ) )
     					{

						if ( ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(back_right - back_left)).y * ( (back_right - (pGameObjectArray[1]->pos + (sdir*10000) ) ).CrossProduct(back_right - back_left)).y < 0 ) ||
       ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(back_right - front_right)).y * ( (back_right - (pGameObjectArray[1]->pos + (sdir*10000) ) ).CrossProduct(back_right - front_right)).y < 0 ) )*/


          if  ( ( ( pGameObjectArray[s]->pos - pGameObjectArray[i]->pos ).Rescale(1)).DotProduct(sdir) < 0.0 )  //shoot those in the front, not the back
								{
									
									Vector3f a ,b;
									a = pGameObjectArray[s]->pos - back_right;
         								b = pGameObjectArray[s]->pos - back_left;
									
									sdir = sdir.Rescale(1);
									float backconst = 8;
									
         								if ( ( a.CrossProduct(sdir).y >= 0 ) && ( sdir.CrossProduct(b).y >= 0 ) )
       									{

          									Vector3f ab = back_left - back_right;

										float d = -ab.x*sdir.z + ab.z*sdir.x;
										float k = -(pGameObjectArray[s]->pos.x - back_right.x)*sdir.z+
												(pGameObjectArray[s]->pos.z - back_right.z)*sdir.x;
										k/=d;
										float dist = -(pGameObjectArray[s]->pos.x - back_right.x)*ab.z+
												(pGameObjectArray[s]->pos.z - back_right.z)*ab.x;
										dist /=d;

										if ( dist < distance) 
										{
											//cout << i << " back " << dist <<endl;

											distance = dist;
											pGameObjectArray[s]->data[7] = back_right.x + ab.x*k - sdir.x*backconst; 
											pGameObjectArray[s]->data[8] = back_right.z + ab.z*k - sdir.z*backconst;
											index = i;
											
										}

									}//if ( (back_right - back_left)

										b = pGameObjectArray[s]->pos - front_right;
										a = pGameObjectArray[s]->pos - front_left;

									if ( ( a.CrossProduct(sdir).y >= 0 ) && ( sdir.CrossProduct(b).y >= 0 ) )
        								{

										Vector3f ab = front_left - front_right;

										float d = -ab.x*sdir.z + ab.z*sdir.x;
										float k = -(pGameObjectArray[s]->pos.x - front_right.x)*sdir.z+
												(pGameObjectArray[s]->pos.z - front_right.z)*sdir.x;
										k/=d;
										float dist = -(pGameObjectArray[s]->pos.x - front_right.x)*ab.z+
												(pGameObjectArray[s]->pos.z - front_right.z)*ab.x;
										dist /=d;

										if ( dist < distance) 
										{
											//cout << i << " front" <<endl;

											distance = dist;
											pGameObjectArray[s]->data[7] = front_right.x + ab.x*k - sdir.x*backconst; 
											pGameObjectArray[s]->data[8] = front_right.z + ab.z*k - sdir.z*backconst;

											index = i;
											
										}
								        }//if ( (front_right - front_left)...

										a = pGameObjectArray[s]->pos - front_right;
										b = pGameObjectArray[s]->pos - back_right;
          
									if ( ( a.CrossProduct(sdir).y >= 0 ) && ( sdir.CrossProduct(b).y >= 0 ) )
									{
										
										Vector3f ab = back_right - front_right;

										float d = -ab.x*sdir.z + ab.z*sdir.x;
										float k = -(pGameObjectArray[s]->pos.x - front_right.x)*sdir.z+
												(pGameObjectArray[s]->pos.z - front_right.z)*sdir.x;
										k/=d;
										float dist = -(pGameObjectArray[s]->pos.x - front_right.x)*ab.z+
												(pGameObjectArray[s]->pos.z - front_right.z)*ab.x;
										dist /=d;

										if ( dist < distance) 
										{
											//cout << i << " right" <<endl;

											distance = dist;
											pGameObjectArray[s]->data[7] = front_right.x + ab.x*k - sdir.x*backconst; 
											pGameObjectArray[s]->data[8] = front_right.z + ab.z*k - sdir.z*backconst;

											index = i;
											
										}//if ( dist < distance) 
         
									}//if ( (front_right - back_right)...

										b = pGameObjectArray[s]->pos - front_left;
										a = pGameObjectArray[s]->pos - back_left;

									if ( ( a.CrossProduct(sdir).y >= 0 ) && ( sdir.CrossProduct(b).y >= 0 ) )
									{
          
										Vector3f ab = back_left - front_left;

										float d = -ab.x*sdir.z + ab.z*sdir.x;
										float k = -(pGameObjectArray[s]->pos.x - front_left.x)*sdir.z+
												(pGameObjectArray[s]->pos.z - front_left.z)*sdir.x;
										k/=d;
										float dist = -(pGameObjectArray[s]->pos.x - front_left.x)*ab.z+
												(pGameObjectArray[s]->pos.z - front_left.z)*ab.x;
										dist /=d;

										if ( dist < distance) 
										{
											//cout << i << " left" <<endl;
											distance = dist;
											pGameObjectArray[s]->data[7] = front_left.x + ab.x*k - sdir.x*backconst; 
											pGameObjectArray[s]->data[8] = front_left.z + ab.z*k - sdir.z*backconst;

											index = i;
											
										}//if ( dist < distance)

									}//if ( (front_left - back_left)...

								}//if ( ( ((back_right - pGameObjectArray[s]->pos...

					//}//if ( ( ((back_right - pGameObjectArray[s]->pos ).CrossProduct(sdir)).y...

					//cout << "Result: " << index << endl;
	
				}//if ( i != msg.target )

    					if (index==1)//if (index!=-1)
					{

						float dmg = 0.8f;

      						float edmg,admg,gdmg;
      						float tmp1, tmp2, tmp3, sum;
      						tmp1 = (rand()%100)/100.0f; tmp2 = (rand()%100)/100.0f; tmp3 = (rand()%100)/100.0f;
     						sum = tmp1+tmp2+tmp3;
      						sum *= (pGameObjectArray[index]->data[PBTPD_ARMOR]/2.0f) + 0.5f;

						if (pGameObjectArray[index]->data[9]==PBPT_QUAD) dmg*=4;

      						edmg = dmg * tmp1 / sum;
      						admg = dmg * tmp2 / sum;
      						gdmg = dmg * tmp3 / sum;


      						SGameMsg sNewMsg;
		

      						sNewMsg.type = GMSG_DAMAGE;
      						sNewMsg.target = 1;
      						sNewMsg.size = 3;
      						sNewMsg.data = new float[sNewMsg.size];
      						sNewMsg.data[0] = edmg;
      						sNewMsg.data[1] = admg;
      						sNewMsg.data[2] = gdmg;
      						sNewMsg.TimeStemp = pWindowUnit->GetTime();
		
     						this->ActOnMessage(sNewMsg);
      						CPSocketSend(&sNewMsg);

						if ( ( (pGameObjectArray[index]->data[PBTPD_ENGINE]==0) && (pGameObjectArray[index]->data[PBTPD_ARMOR]==0) )||
         						((pGameObjectArray[index]->data[PBTPD_GUN]==0) && (pGameObjectArray[index]->data[PBTPD_ARMOR]==0))||
	 						((pGameObjectArray[index]->data[PBTPD_ENGINE]==0) && (pGameObjectArray[index]->data[PBTPD_GUN]==0)) )
	 					{
							SGameMsg sNewMsg;
		
							sNewMsg.type = GMSG_DEATH;
							sNewMsg.target = 1;
							sNewMsg.size = 0;
							sNewMsg.TimeStemp = pWindowUnit->GetTime();
		
							this->ActOnMessage(sNewMsg);
							CPSocketSend(&sNewMsg);

							
							SGameMsg sNewMsg2;
							sNewMsg2.type = GMSG_FRAG;
							sNewMsg2.target = msg.target;
							sNewMsg2.size = 0;
							sNewMsg2.TimeStemp = pWindowUnit->GetTime();
		
							cout << "Sending Frag to: " <<msg.target << endl;

							this->ActOnMessage(sNewMsg2);
							CPSocketSend(&sNewMsg2);
		
						}//if ( ( (pGameObjectArray[index]->data[PBTPD_ENGINE]==0)...

					}//if (index==-1)

				


			}//if (pGameObjectArray[msg.target]->iActive == true)
			else
			{
				  
				pGameObjectArray[msg.target]->iActive = 1;
				pGameObjectArray[msg.target]->iTimer = pWindowUnit->GetTime()-500;
				pGameObjectArray[msg.target]->data[PBTPD_ENGINE] = 1;
				pGameObjectArray[msg.target]->data[PBTPD_ARMOR] = 1;
				pGameObjectArray[msg.target]->data[PBTPD_GUN] = 1;
				bool b =true;
				while (b)
    				{
    					Vector3f v;
     					int w = pGameObjectArray[0]->data[0];
     					int h = pGameObjectArray[0]->data[1];
	 
    					v.x = random() % 1000;//w;
     					v.y = 0;
     					v.z = random() % 1000;//h;
   
     					if (ACollision(v, msg.target) == v)
     					{      
      						pGameObjectArray[msg.target]->pos = v;
      						b = false;
     					}//if (MCollision(v, msg.target) == v)
	 
    				}//while (b)

			}//else if (pGameObjectArray[msg.target]->iActive == true)
		}//f (msg.TimeStemp - pGameObjectArray[msg.target]->iTimer > 1000 + 2000*(1 - pGameObjectArray[msg.target]->data[PBTPD_GUN]))

	}//if ( msg.type == GMSG_SHOOT )

 

}

void CPanzer_Battalion :: ActOnMessages()
{
	
 pThreadUnit->LockMutex(iMSGMutex);	
	
 if (MsgArray.empty()) 
 {
	 pThreadUnit->UnlockMutex( iMSGMutex );
	 return;
 }
 
  int execution_started = 0;
  int tw = 0;
 for (int i = 0; i < MsgArray.size(); i++)
  {

          
	if ( ( MsgArray[i].executed == false ) || ( execution_started == 1 ) )
	{

  		Uint32 t = pWindowUnit->GetTime() - MsgArray[i].TimeStemp;

		if ( (execution_started == 0) && ( MsgArray[i].late == true) )
		{
			fprintf(output,"Warping %d seconds, caused by a %d ms lag and msgtype %s, at time %d \n ",
                                       t / 1000 + 1, t, getMsgString(MsgArray[i].type),pWindowUnit->GetTime());
			SavedStates.GetState(pGameObjectArray,  t / 1000 + 1 );
			pSoundUnit->bSoundOn = false;
                        tw = 1;
			while ( MsgArray[i].TimeStemp > SavedStates.GetTime(t / 1000 + 1) )
				i--;			
		}

                execution_started = 1;

                if ( (MsgArray[i].executed == false) || 
                                            (MsgArray[i].type == GMSG_CHANGE_ANGLES) || 
					    (MsgArray[i].type == GMSG_ACCELERATE) ||
                                            (MsgArray[i].type == GMSG_SHOOT) )
                {
			MsgArray[i].executed = true;
			this->ActOnMessage(MsgArray[i]);
                }

	}
   	

  }
    pSoundUnit->bSoundOn = true;
	/*int k = 0;
  for ( int i = 0; i < MsgArray.size(); i++ )
	{

		if ( pWindowUnit->GetTime() - MsgArray[i].TimeStemp < PB_MSG_LIFE )
       		    {
			k=i;
			break;
		    }
	}

  for ( int i = 0; i < k;i++)
	{
		MsgArray.erase( MsgArray.begin() );
	}*/
 
  SavedStates.SaveState(pGameObjectArray, pWindowUnit->GetTime());

 pThreadUnit->UnlockMutex( iMSGMutex );
 
}

int CPanzer_Battalion :: LoadModels(char* c)
{
 cout << "loading models\n";

 pGraphicUnit->LoadObjects(c);
 
 
 return 1;
};

int CPanzer_Battalion :: LoadTextures(char* c)
{
 cout << "loading textures\n";
 
 pGraphicUnit->LoadTextures(c);
 
 
 return 1;
};

void CPanzer_Battalion :: CalculateBB(SGameObject &o)
{
 SGraphicObject* g;
 
 g = pGraphicUnit->GetObject(o.iGraphicObjectId); 
 Vector3f* v = pGraphicUnit->GetVertices();
 
 o.back = o.front = v[g->pIndexArray[0]].z;
 o.right = o.left = v[g->pIndexArray[0]].x;
 
 for (int i =1; i < g->iIndexCount;i++ )
 {
  
  if ( o.back < v[g->pIndexArray[i]].z ) o.back = v[g->pIndexArray[i]].z;
  if ( o.front > v[g->pIndexArray[i]].z ) o.front = v[g->pIndexArray[i]].z;
  if ( o.right > v[g->pIndexArray[i]].x ) o.right = v[g->pIndexArray[i]].x;
  if ( o.left < v[g->pIndexArray[i]].x ) o.left = v[g->pIndexArray[i]].x;
   
 }
 
 
 
}

int CPanzer_Battalion :: AddGameObject( SGameObject* obj )
{
	this->CalculateBB(*obj);
	pGameObjectArray.push_back(obj);
	iGameObjectCount++;
	return pGameObjectArray.size()-1;
}
int CPanzer_Battalion :: LoadObjects(char* c)
{
 cout << "loading objects\n";
 
 FILE* f = fopen(c,"r");
 
 fscanf( f, "%d", &iGameObjectCount);
 SGameObject* tmpObject;
 
 for ( int i = 0; i < iGameObjectCount; i++ )
 {
 	tmpObject = new SGameObject;

  fscanf(f,"%d",&(tmpObject->type));
  fscanf(f,"%d",&(tmpObject->iGraphicObjectId));
  fscanf(f,"%f",&(tmpObject->pos.x));
  fscanf(f,"%f",&(tmpObject->pos.y));
  fscanf(f,"%f",&(tmpObject->pos.z));
  fscanf(f,"%f",&(tmpObject->rot.x));
  fscanf(f,"%f",&(tmpObject->rot.y));
  fscanf(f,"%f",&(tmpObject->rot.z));
  fscanf(f,"%d",&(tmpObject->iTexture1Id));
  fscanf(f,"%d",&(tmpObject->iTexture2Id));
  fscanf(f,"%f",&(tmpObject->color[0]));
  fscanf(f,"%f",&(tmpObject->color[1]));
  fscanf(f,"%f",&(tmpObject->color[2]));
  fscanf(f,"%f",&(tmpObject->color[3]));
  this->CalculateBB(*tmpObject); 
  tmpObject->iActive = 1;


  if (tmpObject->type == PBOT_NORMAL)
   pGameObjectArray.push_back(tmpObject);
  else
  if (tmpObject->type == PBOT_POWERUP)
  {
	
   SGamePowerup* tmpSGamePowerup = new SGamePowerup(*tmpObject);
   fscanf(f,"%f",&(tmpSGamePowerup->data[0]));
   tmpSGamePowerup->iTimer = pWindowUnit->GetTime();
   tmpSGamePowerup->iActive = 1;
  // fscanf(f,"%f",&tmpSGamePowerup->data[0]);
   pGameObjectArray.push_back(tmpSGamePowerup);
  }
  if (tmpObject->type == PBOT_TANK_PROTOTYPE)
  {
   STankPrototype* tmpTankprototype = new STankPrototype(*tmpObject);
   fscanf(f,"%f",&(tmpTankprototype->data[0]));
   fscanf(f,"%f",&(tmpTankprototype->data[1]));
   tmpTankprototype->iTimer = pWindowUnit->GetTime();
   tmpTankprototype->iActive = 0;
   pGameObjectArray.push_back(tmpTankprototype);
  }
  if (tmpObject->type == PBOT_MAP)
  {
   tmpObject->size = 2;
   tmpObject->data = new float[tmpObject->size];
   tmpObject->data[0] = pGraphicUnit->pVertexArray[pGraphicUnit->pGraphicObjectArray[tmpObject->iGraphicObjectId].pIndexArray[0]].x;
   if (tmpObject->data[0]<0) tmpObject->data[0] = -tmpObject->data[0];

   tmpObject->data[1] = pGraphicUnit->pVertexArray[pGraphicUnit->pGraphicObjectArray[tmpObject->iGraphicObjectId].pIndexArray[0]].z;
   if (tmpObject->data[1] < 0) tmpObject->data[1] = -tmpObject->data[1];

   pGameObjectArray.push_back(tmpObject);
  }
   if (tmpObject->type == PBOT_SHOT)
   {
   GameEffectObjectArray.push_back(i);
   tmpObject->iActive = 0;
   pGameObjectArray.push_back(tmpObject);
   
   }else
   if (tmpObject->type == -2)
   {
	 pGameObjectArray.push_back(tmpObject);
   }

   
 }

 
 cout << "objects loaded" << endl;
 return 1;
};

void CPanzer_Battalion :: AddMsg(SGameMsg msg, bool Lock)
{
	if (Lock)
	pThreadUnit->LockMutex(iMSGMutex);


	//cout << pWindowUnit->GetTime() <<" "<<msg.TimeStemp<< endl;
	/*if (pWindowUnit->GetTime() - msg.TimeStemp > PB_MSG_LIFE ) 
	    {
		pThreadUnit->UnlockMutex(iMSGMutex);
		return;
	    }*/


 if (msg.type>0)
{
 
  vector<SGameMsg>::iterator it = MsgArray.begin();
int i;
  for (i = 0;i<MsgArray.size();i++)
  {
    if (MsgArray[i].TimeStemp > msg.TimeStemp)
	{
	  //cout << "time warp"<<endl;
	  msg.late = true;
	  MsgArray.insert(it,msg);
          break;
	}
     it++;
  }

   if (i==MsgArray.size()) MsgArray.push_back(msg);
}

 else
 {
  vector<SGameMsg>::iterator Iterator;
     Iterator = MsgArray.begin();
  for (uint i = 0; i < MsgArray.size(); i++, Iterator++)
  {
   if ( ( Iterator->type == - msg.type ) && ( Iterator->target == msg.target ) )
    MsgArray.erase(Iterator);
  }
 }
 
 if (Lock)
 pThreadUnit->UnlockMutex(iMSGMutex);
}

int CPanzer_Battalion :: LoadShaders(char* c)
{
 cout << "loading shaders\n";
 
 pGraphicUnit->LoadShaders(c);
 
 return 1;
};

int CPanzer_Battalion :: LoadSounds(char* c)
{
	
	pSoundUnit->LoadSounds(c);
}
