/***************************************************************************
 *            CpGl.h
 *-lxerces-c -lxerces-depdom
 *  Tue Dec 26 00:49:01 2006
 *  Copyright  2006  Stefan Tolic
 ****************************************************************************/
#define LOAD_FROM_BLOB
 
 
#include <math.h>
#include <CpGl.h>
#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <GL/glu.h>
#include <SDL/SDL.h>

#define LOAD_FROM_BLOB

#ifndef LOAD_FROM_BLOB
#include <SAX/ArabicaConfig.h>
#include <CpColladaParser.h>
#endif

#include <math.h>
#include <IL/il.h>
#include <IL/ilut.h>

#define FAR 	4500.0
#define NEAR 10.0

#define GLOWWTH    256
#define GLOWHTH	    256


int m_indexBuffer;
float min(float a, float b)
{
	return a<b ? a : b;
}

int phase = 1;

void set_frustum()
{
   //  glFrustum(-0.1,0.1,-0.1,0.1,NEAR/100.0,FAR);


      float Near =NEAR;
      float Far =FAR;
      float Right = 10;
      float Left = -10;
      float Bottom = -10;
      float Top = 10;


	float Pinf[4][4]; 
	Pinf[1][0] = Pinf[2][0] = Pinf[3][0] = Pinf[0][1] = Pinf[2][1] = Pinf[3][1] = Pinf[0][2] = Pinf[1][2] = Pinf[0][3] = Pinf[1][3] = Pinf[3][3] = 0;

	Pinf[0][0] = 2*Near/(Right-Left); 
	Pinf[1][1] = 2*Near/(Top-Bottom); 
	Pinf[3][2] = -2*Near; Pinf[2][2] = Pinf[2][3] = -1;


	glMatrixMode(GL_PROJECTION); 
	glLoadMatrixf(&Pinf[0][0]);

	glEnable(GL_DEPTH_CLAMP_NV);
}

using namespace std;

const int DEFAULT_SHADER = 3;

GLuint depth2;

CCpGl::CCpGl()
{

	shmd = 1;
	mm=1;
	tq=1;
	sh=1;
 glewInit();
 glEnableClientState(GL_VERTEX_ARRAY);
 glEnableClientState(GL_TEXTURE_COORD_ARRAY);
 glEnableClientState(GL_NORMAL_ARRAY);
 glEnable(GL_TEXTURE_2D);
 glEnable(GL_DEPTH_TEST);
 glFrontFace(GL_CCW);
 glEnable(GL_CULL_FACE);
 glEnable(GL_BLEND);


 //glEnable(GL_ALPHA_TEST);
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);//GL_DST_ALPHA,GL_SRC_ALPHA);
	glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluLookAt(0,0,0,0,0,-1,0,1,0);
	sPos = Vector3f(0.0, 40.0, 25.0);
	dx=dy=0.0;
	dz=-1.0;
	ax=0.0;
	ay=180.0;
	lmap=0;
	cout << "Init: CpGl\n";
	ilInit();
	ilutRenderer(ILUT_OPENGL);

//glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	LX=LZ=10.0;


	glGenTextures( 1, &iMinimap );

	glBindTexture( GL_TEXTURE_2D, iMinimap );
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 1024, 1024, 0,
                   	  GL_RGBA, GL_UNSIGNED_INT, NULL);



//-------------------------------------------------------------------------------------------------------------------------------------

	glGenFramebuffersEXT(1,&iScreen);

	glGenTextures( 1, &iColor );

	glBindTexture( GL_TEXTURE_2D, iColor );
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
//	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
//	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage.width, TextureImage.height, GL_RGB, GL_UNSIGNED_BYTE, TextureImage.pixels)

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0,
                   	  GL_RGBA, GL_FLOAT, NULL);

	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0,
                   	  GL_RGBA, GL_HALF_FLOAT_ARB, NULL);*/


	glGenRenderbuffersEXT(1, &iDepth);
	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT, iDepth);
	glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_DEPTH_COMPONENT24, RESOLUTION_WIDTH, RESOLUTION_HIGHT);
	

	cout << gluErrorString(glGetError())<<endl;

	glGenTextures( 1, &depth2 );
	glBindTexture( GL_TEXTURE_2D, depth2 );
	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0,
                   	  GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, NULL);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);*/
	glTexImage2D (GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT32_ARB, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_INT, NULL);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);


//-----------------------------------------------------------------------------------------------------------------------------------

	glGenFramebuffersEXT(1,&iGlowScreen);

	glGenTextures( 1, &iGlowColor );

	glBindTexture( GL_TEXTURE_2D, iGlowColor );
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB, GLOWWTH, GLOWWTH, 0,
                   	  GL_RGBA, GL_HALF_FLOAT_ARB, NULL);*/


	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, GLOWWTH, GLOWWTH, 0,
                   	  GL_RGBA, GL_UNSIGNED_INT, NULL);

	cout << gluErrorString(glGetError())<<endl;

	glGenTextures( 1, &iGlowDepth );
	glBindTexture( GL_TEXTURE_2D, iGlowDepth );
	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0,
                   	  GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, NULL);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);*/
	glTexImage2D (GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT32_ARB, GLOWWTH, GLOWWTH, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_INT, NULL);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

//-----------------------------------------------------------------------------------------------------------------------------------

	glGenFramebuffersEXT(1,&iGlowScreen2);

	glGenTextures( 1, &iGlowColor2 );

	glBindTexture( GL_TEXTURE_2D, iGlowColor2 );
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB, GLOWWTH, GLOWWTH, 0,
                   	  GL_RGBA, GL_HALF_FLOAT_ARB, NULL);*/


	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, GLOWWTH, GLOWWTH, 0,
                   	  GL_RGBA, GL_UNSIGNED_INT, NULL);

	cout << gluErrorString(glGetError())<<endl;

	glGenTextures( 1, &iGlowDepth2 );
	glBindTexture( GL_TEXTURE_2D, iGlowDepth2 );
	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0,
                   	  GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, NULL);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);*/
	glTexImage2D (GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT32_ARB, GLOWWTH, GLOWWTH, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_INT, NULL);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

//-----------------------------------------------------------------------------------------------------------------------------------

	glGenFramebuffersEXT(1,&iGlowScreen3);

	glGenTextures( 1, &iGlowColor3 );

	glBindTexture( GL_TEXTURE_2D, iGlowColor3 );
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB, GLOWWTH, GLOWWTH, 0,
                   	  GL_RGBA, GL_HALF_FLOAT_ARB, NULL);*/


	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, GLOWWTH, GLOWWTH, 0,
                   	  GL_RGBA, GL_UNSIGNED_INT, NULL);

	cout << gluErrorString(glGetError())<<endl;

	glGenTextures( 1, &iGlowDepth3 );
	glBindTexture( GL_TEXTURE_2D, iGlowDepth3 );
	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0,
                   	  GL_DEPTH_COMPONENT, GL_UNSIGNED_BYTE, NULL);
	glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);*/
	glTexImage2D (GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT32_ARB, GLOWWTH, GLOWWTH, 0, GL_DEPTH_COMPONENT, GL_UNSIGNED_INT, NULL);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);

//-----------------------------------------------------------------------------------------------------------------------------------

	glGenFramebuffersEXT(1,&iStencilScreen);

	glGenTextures( 1, &iStencilColor );

	glBindTexture( GL_TEXTURE_2D, iStencilColor );
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	/*glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA16F_ARB, GLOWWTH, GLOWWTH, 0,
                   	  GL_RGBA, GL_HALF_FLOAT_ARB, NULL);*/


	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, RESOLUTION_WIDTH, RESOLUTION_HIGHT, 0,
                   	  GL_RGBA, GL_FLOAT, NULL);

	cout << gluErrorString(glGetError())<<endl;

//-----------------------------------------------------------------------------------------------------------------------------------
	cout << gluErrorString(glGetError())<<endl;

	int a=1;

	

	SDL_GL_GetAttribute(SDL_GL_MULTISAMPLEBUFFERS, &a);
	cout << "SDL_GL_MULTISAMPLEBUFFERS " << a <<endl;

	SDL_GL_GetAttribute(SDL_GL_MULTISAMPLESAMPLES, &a);
	cout << "SDL_GL_MULTISAMPLESAMPLES " << a <<endl;

	glEnable(GL_MULTISAMPLE);

	glEnable (GL_BLEND);
	glEnable (GL_POLYGON_SMOOTH);

   	glHint (GL_POLYGON_SMOOTH_HINT, GL_NICEST);


	glGetIntegerv(GL_SAMPLE_BUFFERS_ARB,&a);

	cout << "SAMPLE_BUFFERS_ARB: " << a << endl;

	//glSampleCoverageARB();

	

}

int CCpGl::LoadShader(char* fs, char* vs, GLuint i)
{
	char  *shaderSource, *errorLog;
  	int    shaderLength, tempInt;
  	int error;
	  
 	FILE * fIn;
  	FILE * fDeb;

	Shaders[i] = glCreateProgramObjectARB ();
	GLhandleARB fragmentShader = glCreateShaderObjectARB ( GL_FRAGMENT_SHADER_ARB );
	GLhandleARB vertexShader  = glCreateShaderObjectARB ( GL_VERTEX_SHADER_ARB );
//--------------------VERTEX SHADER--------------------------	
	fIn = fopen(vs,"r");
	
	if (fIn==NULL)
	{
		cout << "Failed to open file: " << vs << "\n";
		return 0;
	} 
	
	cout << "   Loading file: " << vs << endl;
	
  	fseek( fIn, 0, SEEK_END );
  	shaderLength = ftell( fIn );
  	fseek( fIn, 0, SEEK_SET);
  	shaderSource = new char[shaderLength+1];
  	shaderLength=fread( shaderSource, 1, shaderLength, fIn ); 
  	fclose( fIn );
  
  	shaderSource[shaderLength] = '\0';
	
	glShaderSourceARB ( vertexShader, 1, (const char**)&shaderSource, NULL );
 	glCompileShaderARB ( vertexShader );
  	glGetObjectParameterivARB ( vertexShader, GL_OBJECT_COMPILE_STATUS_ARB, &error );
	
	errorLog = new char[2000];  
  
  	glGetInfoLogARB( vertexShader, 2000, &tempInt, errorLog);
  	printf (  "%s", errorLog );
    

  	if ( !error ) 
  	{
       return 0;
  	}

	glAttachObjectARB ( Shaders[i], vertexShader );

	{GLenum e;
  	if ( (e=glGetError ()) != GL_NO_ERROR )
  	{
		cout <<"Attach Error\n";
		cout << gluErrorString(e)<<endl;
       return 0;
  	}}
	delete []errorLog;

//--------------------Fragment SHADER--------------------------	
	fIn = fopen(fs,"r");
	
	if (fIn==NULL)
	{
		cout << "Failed to open file: " << fs << "\n";
		return 0;
	}
	
	cout << "      Loading file: " << fs << endl;
	
  	fseek( fIn, 0, SEEK_END );
  	shaderLength = ftell( fIn );
  	fseek( fIn, 0, SEEK_SET);
  	shaderSource = new char[shaderLength+1];
  	shaderLength=fread( shaderSource, 1, shaderLength, fIn ); 
  	fclose( fIn );
	 	
  	shaderSource[shaderLength] = '\0';
	
	glShaderSourceARB ( fragmentShader, 1, (const char**)&shaderSource, NULL );
  	glCompileShaderARB ( fragmentShader );
  	glGetObjectParameterivARB ( fragmentShader, GL_OBJECT_COMPILE_STATUS_ARB, &error );
	
	errorLog = new char[2000];  
  
  	glGetInfoLogARB( fragmentShader, 2000, &tempInt, errorLog);
  	printf (  "%s", errorLog );
	   
  	if ( !error ) 
  	{
       return 0;
  	}
	
  	glAttachObjectARB ( Shaders[i], fragmentShader );
	
	cout << "         Linking" << endl;
	
	glLinkProgramARB ( Shaders[i] );
	{GLenum e;
  	if ( (e=glGetError ()) != GL_NO_ERROR )
  	{
		cout <<"Link Error\n";
		cout << gluErrorString(e)<<endl;
       return 0;
  	}}
	delete []errorLog;


	return 1;
}

int CCpGl::LoadShaders(char* c)
{
	
	FILE* f;
	
	f = fopen(c,"r");
	
	GLuint count;
	char fs[100];
	char vs[100];
	
	fscanf(f,"%d",&count);
	Shaders = new GLhandleARB[count];

	for (int i = 0; i < count ; i++)
	{
		fscanf(f,"%s",&fs);
		fscanf(f,"%s",&vs);	
		if ( !( LoadShader(fs,vs,i)) ) return 0;
		
	}
	return 1;
}

int CCpGl::LoadTextures(char* c)
{
	
	FILE* f;
	int mml;
	f = fopen(c,"r");
	
	GLuint count, w,h;
	char t[100];
	
	
	fscanf(f,"%d",&count);
	pTextureArray = new GLuint[count];
	
	
	for (int i = 0; i < count ; i++)
	{
		fscanf(f,"%s",&t);
		fscanf(f,"%d",&mml);
		if ( ! ( pTextureArray[i] = LoadTexture(t,mml) ) ) 
		{
			cout << "failed"<<endl;
			return 0;
		}
		
	}
	cout << "textures loaded" <<endl;
	return 1;
}

GLuint CCpGl::LoadTexture(char* TextName, int mml )
{
	
	GLuint Texture;
	cout << "   Loading: "<< TextName <<endl;
	//Texture = ilutGLLoadImage(TextName);

	/*glBindTexture( GL_TEXTURE_2D, Texture );
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR );
    	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR ); //bind the texture to it's array
        glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );

	gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width, height, GL_RGB, GL_UNSIGNED_BYTE, data );

	*/

	ILuint texid;

	ilGenImages(1, &texid); /* Generation of one image name */
  	ilBindImage(texid); /* Binding of image name */
  	ILuint success = ilLoadImage(TextName); /* Loading of image "image.jpg" */
  	if (success) /* If no error occured: */
  	{
    		success = ilConvertImage(ilGetInteger(IL_IMAGE_FORMAT), IL_UNSIGNED_BYTE); /* Convert every colour component into
      		unsigned byte. If your image contains alpha channel you can replace IL_RGB with IL_RGBA */
    		if (!success)
    		{
      			SDL_Quit();
      			return -1;
    		}

    		glGenTextures(1, &Texture); /* Texture name generation */
    		glBindTexture(GL_TEXTURE_2D, Texture); /* Binding of texture name */
    		if (tq)
    		    		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR); 
    		else
    		    		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST); 
                		
    		if (!mm)
    		      mml =0;
    		
		if (mml>0)
		{
    			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
			glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
		}else
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

    		glTexImage2D(GL_TEXTURE_2D, 0, ilGetInteger(IL_IMAGE_BPP), ilGetInteger(IL_IMAGE_WIDTH),
      		ilGetInteger(IL_IMAGE_HEIGHT), 0, ilGetInteger(IL_IMAGE_FORMAT), GL_UNSIGNED_BYTE,
      		ilGetData());


		if (mml>0)
			gluBuild2DMipmaps( GL_TEXTURE_2D, mml, ilGetInteger(IL_IMAGE_WIDTH), ilGetInteger(IL_IMAGE_HEIGHT), GL_RGB, GL_UNSIGNED_BYTE, ilGetData() );

		cout << "      " << TextName <<" loaded\n";
	}
	return Texture;

}

void CCpGl::Clear()
{
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glClearDepth(1.0);
	glClearColor(0.0,0.0,0.0,0.0);
}




int CCpGl::LoadObject(char* c, GLuint iBeginIndex, int genNormals)
{
	iGraphicObjectCount++;
	
	cout << "   Loading "<< c << endl;
/*	
	CCpColladaParser cParser;
	cParser.SetState(CPCP_VERTICES);
	cParser.iStartingIndex = iBeginIndex;
 
	GLuint temp = Mesh.size();
		
	
    try
    {
      SAX::XMLReader<std::string> myParser;
      myParser.setContentHandler(cParser);
      myParser.setErrorHandler(cParser);

      SAX::InputSource is(c);
      myParser.parse(is);
    } // try
    catch(std::runtime_error& e)
    {
      std::cerr << "Parse problem " << e.what() << std::endl;
    }
	
	

	

	for (int i =0;i<cParser.iTempIndicesCount/3;i++)
	{
		if ( strcmp(c,"bla2.dae")  && strcmp(c,"monkey.dae") )
  				Mesh.push_back(cParser.pVertexArray[i]);
		else
  			Mesh.push_back(cParser.pVertexArray[i]*50+Vector3f(0,100,0));
  		Normals.push_back(cParser.pNormalArray[i]);
  		UV.push_back(cParser.pUVArray[i]);
  		lVertexCount++;
	}


	if (genNormals)
	{
		printf("\t\tGenerating Normals\n");
		for (int j=iBeginIndex;j<Mesh.size();j++)
		{

			Vector3f p1 = Vector3f ( 	(Mesh[j].x),
							(Mesh[j].y),
							(Mesh[j].z)	);

			j++;
//------------------------------------------

			Vector3f p2 = Vector3f ( 	(Mesh[j].x),
								(Mesh[j].y),
								(Mesh[j].z)	);

			j++;
//------------------------------------------

			Vector3f p3 = Vector3f ( 	(Mesh[j].x),
								(Mesh[j].y),
								(Mesh[j].z)	);

//------------------------------------------

			Normals[j]=Normals[j-1]=Normals[j-2] =  (p2-p1).CrossProduct( p3-p2 ).Rescale(1);
		
		}
	}

	SGraphicObject tmpGraphicObject;
	
	tmpGraphicObject.x=tmpGraphicObject.y=tmpGraphicObject.z=0.0;
	
	tmpGraphicObject.Texture=0;
	tmpGraphicObject.iIndexCount = cParser.iTempIndicesCount/3;
	tmpGraphicObject.pIndexArray = cParser.pIndexArray;
	

	glGenBuffers(1, &tmpGraphicObject.iIndexBufferId);
	//cout << gluErrorString(glGetError())<<endl;
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, tmpGraphicObject.iIndexBufferId);
	//cout << gluErrorString(glGetError())<<endl;
    	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(unsigned int) * tmpGraphicObject.iIndexCount ,
                     tmpGraphicObject.pIndexArray, GL_STATIC_DRAW);
	//cout << gluErrorString(glGetError())<<endl;
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER_ARB, 0);

	for (int i=0;i<tmpGraphicObject.iIndexCount;i+=3)
	{
		int d1 = tmpGraphicObject.pIndexArray[i];
		int d2 = tmpGraphicObject.pIndexArray[i+1];
		int d3 = tmpGraphicObject.pIndexArray[i+2];



		for (int k=0;k<3;k++)
		{
			bool found = false;

			for (int j=0;j<tmpGraphicObject.edges.size();j++)
			{
				if ( ( (Mesh[d1]==Mesh[tmpGraphicObject.edges[j].l1]) && (Mesh[d2]==Mesh[tmpGraphicObject.edges[j].l2]) ) || 
				     ( (Mesh[d1]==Mesh[tmpGraphicObject.edges[j].l2]) && (Mesh[d2]==Mesh[tmpGraphicObject.edges[j].l1]) ) )
					{
						found = true;
						tmpGraphicObject.edges[j].v2[0]=d1;
						tmpGraphicObject.edges[j].v2[1]=d2;
						tmpGraphicObject.edges[j].v2[2]=d3;
						break;
					}
				
			}

			if (!found)
			{
				Edge e;
				e.v1[0]=d1;
				e.v1[1]=d2;
				e.v1[2]=d3;
				e.v2[0] = e.v2[1] =e.v2[2] =0; 
				e.l1=d1;
				e.l2=d2;
				tmpGraphicObject.edges.push_back(e);
			}
			
			int tmp1, tmp2;
			tmp1=d2;
			tmp2=d3;
			d3=d1;
			d2=tmp2;
			d1=tmp1;
		}	
		
	}

	tmpGraphicObject.iEdgeCount=tmpGraphicObject.edges.size();

	//cout << gluErrorString(glGetError())<<endl;

	pGraphicObjectArray.push_back(tmpGraphicObject);
		*/
	return 1;
}

int CCpGl::LoadObjects(char* c)
{

	

	iGraphicObjectCount = 0;
	lVertexCount = 0;

	glGenBuffersARB(4, vbos);
//#define LOAD_FROM_BLOB

#ifndef LOAD_FROM_BLOB

	FILE* f;
	
	f = fopen(c,"r");
	
	if (f == NULL )
	{
		cout << "Error: Couldn't open " << c << endl;
		return 0;
	}
	
	char s[100];
	int  count, No, genNormals;
	
	fscanf(f,"%d",&count);
	
	for (int i =0;i<count;i++)
	{
		fscanf(f,"%s",&s);
		fscanf(f,"%d",&genNormals);
		LoadObject(s,lVertexCount,genNormals);
		fscanf(f,"%d",&No);
		pGraphicObjectArray[iGraphicObjectCount-1].Texture = No;
		fscanf(f,"%d",&No);
		pGraphicObjectArray[iGraphicObjectCount-1].iShader = No;
		
		fscanf(f,"%f",&pGraphicObjectArray[iGraphicObjectCount-1].color[0]);
		fscanf(f,"%f",&pGraphicObjectArray[iGraphicObjectCount-1].color[1]);
		fscanf(f,"%f",&pGraphicObjectArray[iGraphicObjectCount-1].color[2]);
		fscanf(f,"%f",&pGraphicObjectArray[iGraphicObjectCount-1].color[3]);
		
		fscanf(f,"%f",&pGraphicObjectArray[iGraphicObjectCount-1].diff);
		fscanf(f,"%f",&pGraphicObjectArray[iGraphicObjectCount-1].spec);
		
	}
	


	
	glBindBuffer(GL_ARRAY_BUFFER, vbos[0]);


	pVertexArray = new Vector3f[lVertexCount];
	pTexCordArray = new Vector2f[lVertexCount];
	pNormalArray = new Vector3f[lVertexCount];
	pAttributeArray = new Vector3f[lVertexCount];


	//glBufferData(GL_ARRAY_BUFFER, sizeof(Vector3f) * lVertexCount, 
	//					pVertexArray, GL_STATIC_DRAW);


	for (int i =0; i<lVertexCount; i++)
	{
		pVertexArray[i] = Mesh[i];
		pNormalArray[i] = Normals[i];
		pTexCordArray[i] = UV[i];
		
	}
	for (int i =0; i<lVertexCount; i+=3)
	{	
		Vector3f tmpA = pVertexArray[i] - pVertexArray[i+1];
		Vector2f tmpAt = UV[i] - UV[i+1];
		Vector3f tmpB = pVertexArray[i+1] - pVertexArray[i+2];
        Vector2f tmpBt = UV[i+1] - UV[i+2];
		
		
		Vector3f tmp = tmpA*tmpBt.u-tmpB*tmpAt.u;
		
		if (tmpAt.v*tmpBt.u - tmpAt.u*tmpBt.v < 0 ) tmp = tmp*(-1);
		
		pAttributeArray[i] = pAttributeArray[i+1] = pAttributeArray[i+2] = tmp;
				        		
	}


	FILE* out = fopen("vaf.blob","wb");
	fwrite(pVertexArray,1,sizeof(pVertexArray[0])*lVertexCount,out);
	fclose(out);

	out = fopen("taf.blob","wb");
	fwrite(pTexCordArray,1,sizeof(pTexCordArray[0])*lVertexCount,out);
	fclose(out);

	out = fopen("naf.blob","wb");
	fwrite(pNormalArray,1,sizeof(pNormalArray[0])*lVertexCount,out);
	fclose(out);

	out = fopen("aaf.blob","wb");
	fwrite(pAttributeArray,1,sizeof(pAttributeArray[0])*lVertexCount,out);
	fclose(out);

	out = fopen("oaf.blob","wb");
	for (int i=0;i<pGraphicObjectArray.size();i++)
	{
		char buffer [33];
		sprintf(buffer,"i%d.blob",i);
		FILE* indices_file = fopen(buffer,"wb");
		fwrite(&pGraphicObjectArray[i],1,sizeof(SGraphicObject),out);
		fwrite(pGraphicObjectArray[i].pIndexArray,1,sizeof(unsigned int)*pGraphicObjectArray[i].iIndexCount,indices_file);
		fclose(indices_file);

		sprintf(buffer,"e%d.blob",i);
		FILE* edges_file = fopen(buffer,"wb");
		for (int j=0;j<pGraphicObjectArray[i].iEdgeCount;j++)
			fwrite(&(pGraphicObjectArray[i].edges[j]),1,sizeof(Edge),edges_file);

		fclose(edges_file);

		/*edges_file = fopen(buffer,"rb");
		for (int j=0;j<pGraphicObjectArray[i].iEdgeCount;j++)
		{
			Edge* e=new Edge();
			fread (e,1,sizeof(Edge),edges_file);
			pGraphicObjectArray[i].edges[j] = *e;
			if (j==1)
				cout<<pGraphicObjectArray[i].edges[j].v1[0]<<endl;
		}

		fclose(edges_file);*/
	}
	fclose(out);
#endif
	
#ifdef LOAD_FROM_BLOB

	FILE * pFile;
  	long lSize;
  	size_t result;
	char* buffer;

	pFile = fopen ( "vaf.blob" , "rb" );
	fseek (pFile , 0 , SEEK_END);
  	lSize = ftell (pFile);
  	rewind (pFile);
	buffer = (char*) malloc (sizeof(char)*lSize);	
	result = fread (buffer,1,lSize,pFile);
	fclose(pFile);

	lVertexCount=lSize/sizeof(Vector3f);
	pVertexArray=(Vector3f*)buffer;

	pFile = fopen ( "taf.blob" , "rb" );
	fseek (pFile , 0 , SEEK_END);
  	lSize = ftell (pFile);
  	rewind (pFile);
	buffer = (char*) malloc (sizeof(char)*lSize);	
	result = fread (buffer,1,lSize,pFile);
	fclose(pFile);

	pTexCordArray=(Vector2f*)buffer;

	pFile = fopen ( "naf.blob" , "rb" );
	fseek (pFile , 0 , SEEK_END);
  	lSize = ftell (pFile);
  	rewind (pFile);
	buffer = (char*) malloc (sizeof(char)*lSize);	
	result = fread (buffer,1,lSize,pFile);
	fclose(pFile);

	pNormalArray=(Vector3f*)buffer;

	pFile = fopen ( "aaf.blob" , "rb" );
	fseek (pFile , 0 , SEEK_END);
  	lSize = ftell (pFile);
  	rewind (pFile);
	buffer = (char*) malloc (sizeof(char)*lSize);	
	result = fread (buffer,1,lSize,pFile);
	fclose(pFile);

	pAttributeArray=(Vector3f*)buffer;


	pFile = fopen ( "oaf.blob" , "rb" );
	fseek (pFile , 0 , SEEK_END);
  	lSize = ftell (pFile)/sizeof(SGraphicObject);
  	rewind (pFile);
	buffer = (char*) malloc (sizeof(char)*lSize);

	pGraphicObjectArray.clear();
	iGraphicObjectCount=pGraphicObjectArray.size();

	cout << "Basic stuff done\n";
	for (int i=0; i<lSize; i++)
	{	
		buffer = (char*) malloc (sizeof(SGraphicObject));
		result = fread (buffer,1,sizeof(SGraphicObject),pFile);
		((SGraphicObject*)buffer)->edges.clear();
		pGraphicObjectArray.push_back( *((SGraphicObject*)buffer) );

		char name_buffer [33];
		sprintf(name_buffer,"i%d.blob",i);
		FILE* indices_file = fopen(name_buffer,"rb");
		fseek (indices_file , 0 , SEEK_END);
  		int lindSize = ftell (indices_file);
  		rewind (indices_file);
		buffer = (char*) malloc (lindSize);
		result = fread (buffer,1,lindSize,indices_file);
		pGraphicObjectArray[i].pIndexArray = (unsigned int*) buffer;
		glGenBuffers(1, &pGraphicObjectArray[i].iIndexBufferId);

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, pGraphicObjectArray[i].iIndexBufferId);
    		glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(unsigned int) * pGraphicObjectArray[i].iIndexCount ,
                    pGraphicObjectArray[i].pIndexArray, GL_STATIC_DRAW);
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER_ARB, 0);

		name_buffer [33];
		sprintf(name_buffer,"e%d.blob",i);
		FILE* edge_file = fopen(name_buffer,"rb");
		pGraphicObjectArray[i].edges.clear();
		for (int j=0;j<pGraphicObjectArray[i].iEdgeCount;j++)
		{

			Edge* e=new Edge();
			fread (e,1,sizeof(Edge),edge_file);
			pGraphicObjectArray[i].edges.push_back(*e);
		}
		
		cout << name_buffer <<"\n";

		fclose(indices_file);
		fclose(edge_file);
	}
	fclose(pFile);

#endif

	glBindBuffer(GL_ARRAY_BUFFER, vbos[0]);
	glBufferData(GL_ARRAY_BUFFER, sizeof(Vector3f) * lVertexCount, pVertexArray, GL_STATIC_DRAW);
	glVertexPointer( 3,GL_FLOAT,0,0);
	
	glBindBuffer(GL_ARRAY_BUFFER, vbos[1]);
	glBufferData(GL_ARRAY_BUFFER, sizeof(Vector2f) * lVertexCount, pTexCordArray, GL_STATIC_DRAW);
	
	glTexCoordPointer(2,GL_FLOAT,0,0);
	
	glBindBuffer(GL_ARRAY_BUFFER, vbos[2]);
	glBufferData(GL_ARRAY_BUFFER, sizeof(Vector3f) * lVertexCount, pNormalArray, GL_STATIC_DRAW);
	glNormalPointer(GL_FLOAT,0, 0);
	
	glBindBuffer(GL_ARRAY_BUFFER, vbos[3]);
	glBufferData(GL_ARRAY_BUFFER, sizeof(Vector3f) * lVertexCount, pAttributeArray, GL_STATIC_DRAW);
	glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, 0, 0);

	cout << "models loaded" << endl;
	
	
	return 1;
}

int CCpGl::LoadObjectsOld(char* c)
{
	
	cout << "loading objects test\n";
	
/*	iTextureCount =2;
	pTextureArray = new GLuint[iTextureCount];
	pTextureArray[0] = LoadTexture(1024,1024,"tex2.bmp");
*/	
	glGenBuffers(3, vbos);
	
	iGraphicObjectCount=1;
	//pGraphicObjectArray = new SGraphicObject[1];
    pVertexArray = new Vector3f[4];
	lVertexCount = 8;
	
	pVertexArray[0].x=-5;
	pVertexArray[0].y=-2;
	pVertexArray[0].z=-5;
	
	pVertexArray[1].x= 5;
	pVertexArray[1].y=-2;
	pVertexArray[1].z=-5;
	
	pVertexArray[2].x= 5;
	pVertexArray[2].y=-2;
	pVertexArray[2].z= 5;
	
	pVertexArray[3].x=-5;
	pVertexArray[3].y=-2;
	pVertexArray[3].z= 5;
	
	
	/*     Piramida
	
	pVertexArray[4].x=-2; 
	pVertexArray[4].y= 2;
	pVertexArray[4].z=-2;
	
	pVertexArray[5].x= 2;
	pVertexArray[5].y= 2;
	pVertexArray[5].z=-2;
	
	pVertexArray[6].x= 2;
	pVertexArray[6].y= 2;
	pVertexArray[6].z= 2;
	
	pVertexArray[7].x= 2;
	pVertexArray[7].y= 6;
	pVertexArray[7].z= 2;
	*/
	
	glBindBuffer(GL_ARRAY_BUFFER, vbos[0]);
	glBufferData(GL_ARRAY_BUFFER, sizeof(Vector3f) * 4, pVertexArray, GL_STATIC_DRAW);
	//glVertexPointer(3, GL_FLOAT, 0, 0);
	
	pTexCordArray = new Vector2f[4];
	lTexCordCount = 4;
	
	pTexCordArray[0].u= 0;
	pTexCordArray[0].v= 0;
	
	pTexCordArray[1].u= 1;
	pTexCordArray[1].v= 0;
	
	pTexCordArray[2].u= 1;
	pTexCordArray[2].v= 1;
	
	pTexCordArray[3].u= 0;
	pTexCordArray[3].v= 1;
	
	/*pTexCordArray[4].u= 0;
	pTexCordArray[4].v= 0;
	
	pTexCordArray[5].u= 1;
	pTexCordArray[5].v= 0;
	
	pTexCordArray[6].u= 1;
	pTexCordArray[6].v= 1;
	
	pTexCordArray[7].u= 0;
	pTexCordArray[7].v= 1;
	*/
	glBindBuffer(GL_ARRAY_BUFFER, vbos[1]);
	glBufferData(GL_ARRAY_BUFFER, sizeof(Vector2f) * 4, pTexCordArray, GL_STATIC_DRAW);
	//glTexCoordPointer(2, GL_FLOAT, 0, 0);
	
	ibos = new unsigned int[1];
	
	pGraphicObjectArray[0].Texture=1;
	
	pGraphicObjectArray[0].pIndexArray = new GLuint[6];
	pGraphicObjectArray[0].iIndexCount = 6;
	
	pGraphicObjectArray[0].pIndexArray[0]=0;
	pGraphicObjectArray[0].pIndexArray[1]=1;
	pGraphicObjectArray[0].pIndexArray[2]=3;
	pGraphicObjectArray[0].pIndexArray[3]=1;
	pGraphicObjectArray[0].pIndexArray[4]=2;
	pGraphicObjectArray[0].pIndexArray[5]=3;
	pGraphicObjectArray[0].x = pGraphicObjectArray[0].y =pGraphicObjectArray[0].z =0;
	
	/*glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,ibos[0]);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER,sizeof(GLuint)*6,
					pGraphicObjectArray[0].pIndexArray,GL_STATIC_DRAW);*/
	
	pGraphicObjectArray[1].Texture=0;
	
	pGraphicObjectArray[1].pIndexArray = new GLuint[12];
	pGraphicObjectArray[1].iIndexCount = 12;
	
	pGraphicObjectArray[1].pIndexArray[10]=6;
	pGraphicObjectArray[1].pIndexArray[11]=7;
	pGraphicObjectArray[1].x = pGraphicObjectArray[1].y =pGraphicObjectArray[1].z =0;
	
	
	glColor4ubv( red );
	/*glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,ibos[1]);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER,sizeof(GLuint)*12,
					pGraphicObjectArray[1].pIndexArray,GL_STATIC_DRAW);*/
	
	
	
	/* till here                       */
	glVertexPointer( 3,GL_FLOAT,0,pVertexArray );
	if (GLEW_ARB_fragment_program) cout << "GLEW_ARB_fragment_program suported\n";
	glTexCoordPointer(2,GL_FLOAT,0,pTexCordArray);
	
	cout << "objects loaded\n";
	
	return 1;
}

void CCpGl::SaveMatrixState()
{
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glMatrixMode(GL_TEXTURE);
  glPushMatrix();

}

void CCpGl::LoadMatrixState()
{
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
  glMatrixMode(GL_TEXTURE);
  glPopMatrix();

}

void CCpGl::IdentityAll()
{
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
}

void CCpGl::DrawImage(float x1, float y1, float x2, float y2, float u1, float v1, float u2, float v2, int img, int flag)
{


  glDisable(GL_COLOR);
  glDisable(GL_DEPTH_TEST);
  glEnable(GL_TEXTURE_2D);
  glDisable(GL_CULL_FACE);

    glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		gluOrtho2D(0,1,0,1);

        glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	    glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);

  glActiveTextureARB(GL_TEXTURE1_ARB);
  glBindTexture(GL_TEXTURE_2D, iGlowColor ); 

if (flag==1)
{
  glActiveTextureARB(GL_TEXTURE0_ARB);
  glBindTexture(GL_TEXTURE_2D, pTextureArray[ img ] ); 

   glUseProgramObjectARB ( Shaders [DEFAULT_SHADER] );
  PrepairShader( -3 );

}
else
if (flag==0)
{
   glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D, img ); 

  glUseProgramObjectARB ( Shaders [7] );
  PrepairShader( "Splash",0 );

   glActiveTextureARB(GL_TEXTURE1_ARB);
  glBindTexture(GL_TEXTURE_2D, iGlowColor3 ); 

    glActiveTextureARB(GL_TEXTURE2_ARB);
  glBindTexture(GL_TEXTURE_2D, iStencilColor ); 

}else
if (flag==-1)
{
   glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D, img ); 

  glUseProgramObjectARB ( Shaders [8] );
  PrepairShader( "Splash",0 );

	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	    glViewport(0,0,GLOWWTH,GLOWHTH);

}else
if (flag==-2)
{
   glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D, img ); 

  glUseProgramObjectARB ( Shaders [DEFAULT_SHADER] );
  PrepairShader( -3 );



}
else
if (flag==-3)
{
glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D, img ); 

  glUseProgramObjectARB ( Shaders [9] );
  PrepairShader( -3 );

	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	    glViewport(0,0,GLOWWTH,GLOWHTH);
}else
if (flag==-4)
{
   glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D, img ); 

  glUseProgramObjectARB ( Shaders [DEFAULT_SHADER] );
  PrepairShader( -3 );

   glActiveTextureARB(GL_TEXTURE1_ARB);
  glBindTexture(GL_TEXTURE_2D, 0 ); 
}else
if (flag==-10)
{
   glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D, img ); 

  glUseProgramObjectARB ( Shaders [10] );
  PrepairShader( -3 );

	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	    glViewport(0,0,GLOWWTH,GLOWHTH);

}else
if (flag==-11)
{
   glActiveTextureARB(GL_TEXTURE0_ARB);
   glBindTexture(GL_TEXTURE_2D, img ); 

  glUseProgramObjectARB ( Shaders [11] );
  PrepairShader( -3 );

	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	    glViewport(0,0,GLOWWTH,GLOWHTH);

}

     GLenum e = glGetError();
    

		//glOrtho(-10,10,-10,10,0.01,1000);	


  //glFlush();
  glBegin(GL_TRIANGLES);

  glTexCoord2f(u1,v2);
  glVertex3f(x1,y1,1.0f);

  glTexCoord2f(u2,v2);
  glVertex3f(x2,y1,1.0f);

  glTexCoord2f(u2,v1);
  glVertex3f(x2,y2,1.0f);

  glTexCoord2f(u1,v2);
  glVertex3f(x1,y1,1.0f);

  glTexCoord2f(u2,v1);
  glVertex3f(x2,y2,1.0f);

  glTexCoord2f(u1,v1);
  glVertex3f(x1,y2,1.0f);

/*  glVertex3f(x1,y2,1.0f);
  glTexCoord2f(u1,v2);*/
  glEnd();

//glFinish();

	 glActiveTextureARB(GL_TEXTURE2_ARB);
  glBindTexture(GL_TEXTURE_2D, 0 ); 
	glEnable(GL_CULL_FACE);

}

int k=0;
void CCpGl::PrepairObjectForDrawing(int i)
{
	
	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
		set_frustum();
	
	
	glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
	

		//gluPerspective( 45.0f, 4.0 / 3.0, 0.1f, 3000.0f );	
		gluLookAt(0,0,0,dx,dy,dz,0,1,0);
	
	
		vector<SGameObject*> v = GameInterface->GetGameObjects();
	
		glTranslatef(v[i]->pos.x-sPos.x,
					 v[i]->pos.y-sPos.y,
					 v[i]->pos.z-sPos.z);
	
	
		glRotatef(v[i]->rot.x,1,0,0);
		glRotatef(v[i]->rot.y,0,1,0);
		glRotatef(v[i]->rot.z,0,0,1);

		glMatrixMode(GL_TEXTURE); 
		glLoadIdentity();	
		/*float f = GameInterface->GetTime();
		f/=10000.0;
		glTranslatef(f,f,0.0);*/

	    
	   
}

void CCpGl::SetRenderToTexture(GLuint fb, GLuint color, GLuint depth, GLuint stencil)
{
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);

	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,
                                  GL_COLOR_ATTACHMENT0_EXT,
                                  GL_TEXTURE_2D, color, 0);

	glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_TEXTURE_2D, depth, 0);
	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, depth);

	//glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT, GL_DEPTH_ATTACHMENT_EXT, GL_RENDERBUFFER_EXT, depth);
 	/*glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,
                                  GL_DEPTH_ATTACHMENT_EXT,
                                   GL_TEXTURE_2D, depth, 0);*/
}
void CCpGl::SetRenderToScreen()
{
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
}

void CCpGl::DrawDeath()
{
    glDisable(GL_CULL_FACE);

	//glDepthMask(0);
	
	vector<SGameObject*> v = GameInterface->GetGameObjects();
	SGameObject* e = GameInterface->GetGameObjects()[GameInterface->GetGameEffectObjects()[0]];

	unsigned int currentshader = pGraphicObjectArray [ v[0]->iGraphicObjectId].iShader;
	glUseProgramObjectARB ( Shaders [ 
						pGraphicObjectArray [ 
								v[0]->iGraphicObjectId
		                                    ].iShader ] );

	int i = 1;
	if ( ( !GameInterface->GetGameObjects()[i]->iActive ) && (GameInterface->GetTime() - v[i]->iTimer < 2000) )
	{
		

		


		glLineWidth(1);
		PrepairObjectForDrawing(i);
		
				
		glActiveTextureARB(GL_TEXTURE1_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[ v[i]->iTexture2Id ]);
		//glEnable(GL_TEXTURE_2D);
 
		glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[ v[i]->iTexture1Id ] ); 
		//glEnable(GL_TEXTURE_2D);
		

	//	if ( currentshader != pGraphicObjectArray [ v[i]->iGraphicObjectId].iShader )
		{

			currentshader = pGraphicObjectArray [ v[i]->iGraphicObjectId].iShader;
		glUseProgramObjectARB ( Shaders [ 
						pGraphicObjectArray [ 
								v[i]->iGraphicObjectId
		                                    ].iShader ] ); 

		}
		PrepairShader( i );

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexBufferId);

		/*if (i==1)
			{
				 //   glColor4ubv( blue );
				glBegin(GL_TRIANGLES);
					glVertex4f(0,1,0,1);
					glVertex4f(0,100,0,0);
					glVertex4f(100,1,0,1);
				glEnd();
			}*/

		glDrawElements( GL_TRIANGLES, pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexCount,
						GL_UNSIGNED_INT,
						NULL );

		//GetEdges( i );
		

	}

	//glDepthMask(1);
    glEnable(GL_CULL_FACE);
}

void CCpGl::Draw()
{
    if (wf)
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);

	glEnable(GL_DEPTH_TEST);

	DrawMinimap();

	glBindBuffer(GL_ARRAY_BUFFER,vbos[0]);

	//return;
	SetRenderToTexture(iScreen,iColor,depth2,iColor);
	Clear();

	
	glEnable(GL_COLOR);

        glColor4ubv( white );
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);
	
	vector<SGameObject*> v = GameInterface->GetGameObjects();
	SGameObject* e = GameInterface->GetGameObjects()[GameInterface->GetGameEffectObjects()[0]];


	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
		set_frustum();


	DrawBoxEnv();

	unsigned int currentshader = pGraphicObjectArray [ v[0]->iGraphicObjectId].iShader;
	glUseProgramObjectARB ( Shaders [ 
						pGraphicObjectArray [ 
								v[0]->iGraphicObjectId
		                                    ].iShader ] );

	//glDisable(GL_CULL_FACE);

	
    
	for (int i=v.size()-1;i>=0;i--)
	if ( GameInterface->GetGameObjects()[i]->iActive )
	{
		

		if (!fc)
          if ( ( Vector3f(dx,dy,dz).DotProduct( (GameInterface->GetGameObjects()[i]->pos-sPos)/
                              (GameInterface->GetGameObjects()[i]->pos-sPos).Length() )<0.7 ) && (i>1) && (i<65) )
                    continue;


		glLineWidth(1);
		PrepairObjectForDrawing(i);
		
				
		glActiveTextureARB(GL_TEXTURE1_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[ v[i]->iTexture2Id ]);
		//glEnable(GL_TEXTURE_2D);
 
		glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[ v[i]->iTexture1Id ] ); 
		//glEnable(GL_TEXTURE_2D);
		

	//	if ( currentshader != pGraphicObjectArray [ v[i]->iGraphicObjectId].iShader )
		{

			currentshader = pGraphicObjectArray [ v[i]->iGraphicObjectId].iShader;
		glUseProgramObjectARB ( Shaders [ 
						pGraphicObjectArray [ 
								v[i]->iGraphicObjectId
		                                    ].iShader ] ); 

		}
		PrepairShader( i );

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexBufferId);


		glDrawElements( GL_TRIANGLES, pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexCount,
						GL_UNSIGNED_INT,
						NULL );

		//GetEdges( i );
		

	}

	DrawDeath();

	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	//GetEdges(4);

	glUseProgramObjectARB ( Shaders [4] );
	glDisable(GL_TEXTURE_2D);
	glFrontFace(GL_CW);


	glDepthMask(0);
	if (fc)
	for (GLuint i=1;i<v.size();i++)
	if ( GameInterface->GetGameObjects()[i]->iActive )
	{
		
		PrepairObjectForDrawing(i);
		PrepairShader( "Shadow", i );

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexBufferId);

		glDrawElements( GL_TRIANGLES, pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexCount,
						GL_UNSIGNED_INT,
						NULL );
		
		
		//glFinish();
	}
	glDepthMask(1);
	glFrontFace(GL_CCW);
	glEnable(GL_TEXTURE_2D);

	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

	SetRenderToScreen();


	 IdentityAll();
	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	    glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
		set_frustum();

         glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		
		gluLookAt(0,0,0,dx,dy,dz,0,1,0);
	
	glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		
		gluLookAt(0,0,0,dx,dy,dz,0,1,0);

	glTranslatef(-sPos.x,
		     -sPos.y,
		     -sPos.z);

	glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[ v[0]->iTexture2Id ]);

	glUseProgramObjectARB ( Shaders [ DEFAULT_SHADER] ); 

		
		PrepairShader( -3 );

         glPointSize(20.0);
	 glBegin(GL_POINTS);
	 glVertex3f(LX,550,LZ);
	 glEnd();

	


	SetRenderToScreen();
	RenderLights();
	Splash();

	SetRenderToTexture(iStencilScreen,iStencilColor,0,0);

	glClear( GL_COLOR_BUFFER_BIT );

	if (sh)
	for (int i=v.size()-1;i>0;i--)
	if ( GameInterface->GetGameObjects()[i]->iActive )
	{
		

		glLineWidth(1);
		PrepairObjectForDrawing(i);

		GetEdges( i );
	}

	
	SetRenderToScreen();

	
	DrawBlend();
		

	RenderLights();

	Splash();


	 float A = 0.055f;
	 float X = 0.0075f;
        IdentityAll();

	 DrawImage(0.0f,1.0f,1.0f,0.75f,0.001f,0.001f,0.999f,0.999f,10,1);	

	 if (GameInterface->GetGameObjects()[1]->data[PBTPD_ENGINE]<1)
		 DrawImage(0.2f+X,0.925f,X,0.975f,0.0f,0.0f,1.0f,1.0f,4,1);
	 DrawImage(X,0.925f,X+0.2f*min(GameInterface->GetGameObjects()[1]->data[PBTPD_ENGINE],1),0.975f,0.0f,0.0f,1.0f,1.0f,5,1);
	 if (GameInterface->GetGameObjects()[1]->data[PBTPD_ENGINE]>1)
	 	DrawImage(X,0.925f,X+0.2f*(GameInterface->GetGameObjects()[1]->data[PBTPD_ENGINE]-1),0.975f,0.0f,0.0f,1.0f,1.0f,19,1);
	 DrawImage(X,0.975f,0.2f+X,0.925f,0.0f,0.0f,1.0f,1.0f,6,1);

	 if (GameInterface->GetGameObjects()[1]->data[PBTPD_ARMOR]<1)
	 	DrawImage(X,0.925f-A,0.2f+X,0.975f-A,0.0f,0.0f,1.0f,1.0f,4,1);
	 DrawImage(X,0.925f-A,X+0.2f*min(GameInterface->GetGameObjects()[1]->data[PBTPD_ARMOR],1),0.975f-A,0.0f,0.0f,1.0f,1.0f,5,1);
	 if (GameInterface->GetGameObjects()[1]->data[PBTPD_ARMOR]>1)
		DrawImage(X,0.925f-A,X+0.2f*(GameInterface->GetGameObjects()[1]->data[PBTPD_ARMOR]-1),0.975f-A,0.0f,0.0f,1.0f,1.0f,19,1);
	 DrawImage(X,0.975f-A,0.2f+X,0.925f-A,0.0f,0.0f,1.0f,1.0f,7,1);

	  if (GameInterface->GetGameObjects()[1]->data[PBTPD_GUN]<1)
	 	DrawImage(X,0.925f-A*2,0.2f+X,0.975f-A*2,0.0f,0.0f,1.0f,1.0f,4,1);
	 DrawImage(X,0.925f-A*2,X+0.2f*min(GameInterface->GetGameObjects()[1]->data[PBTPD_GUN],1),0.975f-A*2,0.0f,0.0f,1.0f,1.0f,5,1);
	 if (GameInterface->GetGameObjects()[1]->data[PBTPD_GUN]>1)
		DrawImage(X,0.925f-A*2,X+0.2f*(GameInterface->GetGameObjects()[1]->data[PBTPD_GUN]-1),0.975f-A*2,0.0f,0.0f,1.0f,1.0f,19,1);
	 DrawImage(X,0.975f-A*2,0.2f+X,0.925f-A*2,0.0f,0.0f,1.0f,1.0f,8,1);

	
	 int c=0,fcount = GameInterface->GetGameObjects()[1]->data[6];
         float x1=0.20f,x2=0.210f,y1=0.925f-A*3,y2=00.975f-A*3;

	 //fcount = 6543;

	 if ( fcount==0 )        
	 	DrawImage(x1,y1,x2,y2,0.0f,1.0f,70.0f/1024.0f,0.0f,9,1);
	 else 
	 	while (fcount!=0)
		{
			int no = fcount % 10;
			fcount /=10;
			c++;
			DrawImage(x1-c*(x2-x1),y1,x2-c*(x2-x1),y2,0.0f+no*(70.0f/1024.0f),1.0f,70.0f/1024.0f+no*(70.0f/1024.0f),0.0f,9,1);
		}


	DrawImage(0.995,0.9975f,0.785f,0.755f,1,0.0f,0.0,0.75f,iMinimap,-4);

	


}

void CCpGl::DrawBlend()
{

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
		set_frustum();

	vector<SGameObject*> v = GameInterface->GetGameObjects();
	SGameObject* e = GameInterface->GetGameObjects()[GameInterface->GetGameEffectObjects()[0]];

	SetRenderToTexture(iScreen,iColor,0,iColor);

	glDisable(GL_DEPTH_TEST);

	
	for (GLuint i=0;i<v.size();i++)
	if ( GameInterface->GetGameObjects()[i]->iActive )
	{
		if ( v[i]->type == 1 )
		if ( GameInterface->GetTime() - v[i]->iTimer < 500  )
		{
		
	  	  
			glActiveTextureARB(GL_TEXTURE1_ARB);
			glBindTexture(GL_TEXTURE_2D, depth2);
			glEnable(GL_TEXTURE_2D);
		
 
			glActiveTextureARB(GL_TEXTURE0_ARB);
			glBindTexture(GL_TEXTURE_2D, pTextureArray[ e->iTexture1Id ] ); 
			glEnable(GL_TEXTURE_2D);
		
			glUseProgramObjectARB ( Shaders [ 
						pGraphicObjectArray [ 
								e->iGraphicObjectId
		                                    ].iShader ] );
			
		
			PrepairShader( GameInterface->GetGameEffectObjects()[0] ); 

			float a;
			Vector3f dist;
			float deltaX,deltaZ;
			STankPrototype* t = ((STankPrototype*)GameInterface->GetGameObjects()[i]);

			glMatrixMode(GL_TEXTURE); 
			glLoadIdentity();	
			float f = (GameInterface->GetTime() - v[i]->iTimer) / ( 38.5 );
                        int i2 = f;
 			f = i2;
 			glTranslatef(f/14.0,0.0,0.0);

			Vector3f sdir=Vector3f(-sinf(t->rot.y/180.0f*3.14f)*cosf(t->rot.x/180.0f*3.14f),
     			 sinf(t->rot.x/180.0f*3.14f),
       			-cosf(t->rot.y/180.0f*3.14f)*cosf(t->rot.x/180.0f*3.14f));

			dist = sPos -t->pos - Vector3f( 0,56.0,0 );
			//dist = dist.Rescale(1);
			
			Vector3f tmp1,tmp2,tmp3;
			
			tmp1 = dist.CrossProduct(sdir);
			tmp2 = sdir.CrossProduct(tmp1);
			tmp3 = tmp2.Rescale(1);

			
			
		if ((t->data[7]!=-1.0)||(t->data[8]!=-1.0))
		{	
			glEnable(GL_CULL_FACE);

			glActiveTextureARB(GL_TEXTURE1_ARB);
			glBindTexture(GL_TEXTURE_2D, depth2);
			glEnable(GL_TEXTURE_2D);
		
 
			glActiveTextureARB(GL_TEXTURE0_ARB);
			glBindTexture(GL_TEXTURE_2D, pTextureArray[ 20 ] ); 
			glEnable(GL_TEXTURE_2D);


			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();
			gluLookAt(0,0,0,dx,dy,dz,0,1,0);
			glTranslatef(t->data[7]-sPos.x,
					 -sPos.y,
					 t->data[8]-sPos.z);
			

			dist = (Vector3f(sPos.x,0,sPos.z)-Vector3f(t->data[7],0,t->data[8])).Rescale(1);
			a = dist.DotProduct(Vector3f(0,0,-1));
			deltaX=t->data[7]-sPos.x;
			deltaZ=t->data[8]-sPos.z;			
			if (deltaX>0)
			glRotatef(acos(a)*180/3.14,0,1,0); else glRotatef(-acos(a)*180/3.14,0,1,0);

			dist = Vector3f(deltaX,sPos.y,deltaZ).Rescale(1);
			a = dist.DotProduct(Vector3f(deltaX,0,deltaZ).Rescale(1));
			
			if ( sPos.y > 0 )
			glRotatef(acos(a)*180/3.14,1,0,0);
			else
			glRotatef(-acos(a)*180/3.14,1,0,0);

			//glRotatef(90,0,1,0);

			glDrawElements( GL_TRIANGLES, pGraphicObjectArray[ 4 ].iIndexCount,
						GL_UNSIGNED_INT,
						pGraphicObjectArray [ 4 ].pIndexArray );
	
			//glFinish();	
		}

			glMatrixMode(GL_MODELVIEW);
			glLoadIdentity();					
			gluLookAt(0,0,0,dx,dy,dz,0,1,0);
	
			glTranslatef(v[i]->pos.x-sPos.x,
					 v[i]->pos.y-sPos.y,
					 v[i]->pos.z-sPos.z);
	
	
			glRotatef(v[i]->rot.x,1,0,0);
			glRotatef(v[i]->rot.y,0,1,0);
			glRotatef(v[i]->rot.z,0,0,1);


			glMatrixMode(GL_MODELVIEW);

			 glTranslatef( 0,
					 24.4,
					 -37.0);

			a = Vector3f(0,1,0).DotProduct( tmp3 );
			
			//cout << tmp3.CrossProduct(sdir).y << " A==" << a <<" "<< acos(a) << " " << asin(a)*180/3.14<<endl;

			
			if ( tmp3.CrossProduct(sdir).y > 0 )
			glRotatef(asin(a)*180/3.14,0,0,1);
			else
			glRotatef(90+acos(a)*180/3.14,0,0,1);

			//glDisable(GL_CULL_FACE);

			glActiveTextureARB(GL_TEXTURE1_ARB);
			glBindTexture(GL_TEXTURE_2D, pTextureArray[ 3 ]);
			glEnable(GL_TEXTURE_2D);
		
 
			glActiveTextureARB(GL_TEXTURE0_ARB);
			glBindTexture(GL_TEXTURE_2D, pTextureArray[ 3 ] ); 
			glEnable(GL_TEXTURE_2D);


			glDrawElements( GL_TRIANGLES, pGraphicObjectArray[ e->iGraphicObjectId ].iIndexCount,
						GL_UNSIGNED_INT,
						pGraphicObjectArray [ e->iGraphicObjectId ].pIndexArray );
		}	
		
		
        }
	
	SetRenderToScreen();
}

void CCpGl::DrawBoxEnv()
{
	glDisable(GL_DEPTH_TEST);

	glUseProgramObjectARB ( Shaders [DEFAULT_SHADER] );
 	 PrepairShader( -3 );

	glMatrixMode(GL_TEXTURE); 
		glLoadIdentity();

	glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();	
		gluLookAt(0,0,0,dx,dy,dz,0,1,0);

	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);

	glActiveTextureARB(GL_TEXTURE1_ARB);
		glBindTexture(GL_TEXTURE_2D, 0 );

	glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[12] ); 

		glDrawElements( GL_TRIANGLES, 6,
						GL_UNSIGNED_INT,
						pGraphicObjectArray[ 5 ].pIndexArray );

	glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[11] ); 

		glDrawElements( GL_TRIANGLES, 6,
						GL_UNSIGNED_INT,
						pGraphicObjectArray[ 5 ].pIndexArray + 6 );

	glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[13] ); 

		glDrawElements( GL_TRIANGLES, 6,
						GL_UNSIGNED_INT,
						pGraphicObjectArray[ 5 ].pIndexArray +12 );

	glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[16] ); 

		glDrawElements( GL_TRIANGLES, 6,
						GL_UNSIGNED_INT,
						pGraphicObjectArray[ 5 ].pIndexArray +18 );

	glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[14] ); 

		glDrawElements( GL_TRIANGLES, 6,
						GL_UNSIGNED_INT,
						pGraphicObjectArray[ 5 ].pIndexArray +24 );

	glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[15] ); 

		glDrawElements( GL_TRIANGLES, 6,
						GL_UNSIGNED_INT,
						pGraphicObjectArray[ 5 ].pIndexArray +30 );


	glEnable(GL_DEPTH_TEST);
}

void CCpGl::DrawMinimap()
{

	Vector3f tempPos=sPos, tempDir=Vector3f(dx,dy,dz);

	glBindBuffer(GL_ARRAY_BUFFER,vbos[0]);


	Clear();

	if (!GameInterface->GetGameObjects()[1]->iActive) return;

	glEnable(GL_COLOR);

        glColor4ubv( white );
	glEnable(GL_TEXTURE_2D);

	glEnable(GL_DEPTH_TEST);
	
	vector<SGameObject*> v = GameInterface->GetGameObjects();
	SGameObject* e = GameInterface->GetGameObjects()[GameInterface->GetGameEffectObjects()[0]];


	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
	//glViewport(RESOLUTION_WIDTH*0.785f,RESOLUTION_HIGHT*0.755f,RESOLUTION_WIDTH*0.995,RESOLUTION_HIGHT*0.9975f);
		set_frustum();

	

	unsigned int currentshader = pGraphicObjectArray [ v[0]->iGraphicObjectId].iShader;
	glUseProgramObjectARB ( Shaders [ 5 ] );


	sPos = GameInterface->GetGameObjects()[1]->pos;

	sPos.y+= 500;


	dx=0.01;dy=-0.95;dz=0;


	for (int i=v.size()-1;i>=0;i--)
	if ( GameInterface->GetGameObjects()[i]->iActive )
	{
		
		PrepairObjectForDrawing(i);
		
				
		glActiveTextureARB(GL_TEXTURE1_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[ v[i]->iTexture1Id ]);
		glActiveTextureARB(GL_TEXTURE0_ARB);
		glBindTexture(GL_TEXTURE_2D, pTextureArray[ v[i]->iTexture1Id ]);
		
		
		vector<SGameObject*> obj = GameInterface->GetGameObjects();
		
		PrepairShader( i );
		if (pGraphicObjectArray [ v[i]->iGraphicObjectId].iShader==1)
		PrepairShader( -1 ); else PrepairShader( -2 );

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexBufferId);

		glDrawElements( GL_TRIANGLES, pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexCount,
						GL_UNSIGNED_INT,
						NULL );


	}

	glBindTexture(GL_TEXTURE_2D,iMinimap);
	glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 0, 0, 1024, 1024, 0);

	sPos = tempPos;

	dx = tempDir.x;
	dy = tempDir.y;
	dz = tempDir.z;

}

void CCpGl::Splash()
{
   IdentityAll();
   DrawImage(0,0,1,1,0,1/*0.75*/,1,0,iColor,0);
}


void CCpGl::RenderLights()
{

	SetRenderToTexture(iGlowScreen,iGlowColor,iGlowDepth,iColor);

	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	glViewport(0,0,GLOWWTH,GLOWWTH);
		set_frustum();


	Clear();

	glUseProgramObjectARB ( Shaders [ 4 ] );
//	PrepairShader( "Shadow", 0);

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);

	/*IdentityAll();
        glBegin(GL_QUADS);
	glVertex3f(-1,-1,-1);
	glVertex3f(-1,1,-1);
	glVertex3f(1,1,-1);
	glVertex3f(1,-1,-1);
	glEnd();*/

	 glEnable(GL_CULL_FACE);

        glColor4ubv( white );
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	

	DrawBoxEnv();


	GLenum e;
	e = glGetError();

	glBindBuffer(GL_ARRAY_BUFFER,vbos[0]);


	vector<SGameObject*> v = GameInterface->GetGameObjects();
//	SGameObject* e = GameInterface->GetGameObjects()[GameInterface->GetGameEffectObjects()[0]];


	  DrawImage(0,0,1,1,0,1/*0.75*/,1,0,iColor,-3);

	//SetRenderToScreen(); return; 
/*

	glUseProgramObjectARB ( Shaders [ 6 ] );


	for (int i=v.size()-1;i>=0;i--)
	if ( v[i]->iActive ) 
	{
		
		PrepairObjectForDrawing(i);

		PrepairShader( "Color", i );

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexBufferId);



		glDrawElements( GL_TRIANGLES, pGraphicObjectArray[ v[i]->iGraphicObjectId ].iIndexCount,
						GL_UNSIGNED_INT,
						NULL );

	}
*/
	SetRenderToScreen();

	SetRenderToTexture(iGlowScreen2,iGlowColor2,iGlowDepth2,iGlowColor2);
	glUseProgramObjectARB ( Shaders [ 4 ] );
//	PrepairShader( "Shadow", 0);

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);

	Clear();

	IdentityAll();
        glBegin(GL_QUADS);
	glColor4ubv( white );
	glVertex3f(-1,-1,-1);
	glVertex3f(-1,1,-1);
	glVertex3f(1,1,-1);
	glVertex3f(1,-1,-1);
	glEnd();

	 glEnable(GL_CULL_FACE);

        
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	DrawImage(1,1,0.0,0.0,1,0.0f,0.0,1,iGlowColor,-10);

	SetRenderToScreen();

	SetRenderToTexture(iGlowScreen3,iGlowColor3,iGlowDepth3,iColor);
	glUseProgramObjectARB ( Shaders [ 4 ] );
//	PrepairShader( "Shadow", 0);

	glDisable(GL_DEPTH_TEST);
	glDisable(GL_CULL_FACE);

	IdentityAll();
        glBegin(GL_QUADS);
	glVertex3f(-1,-1,-1);
	glVertex3f(-1,1,-1);
	glVertex3f(1,1,-1);
	glVertex3f(1,-1,-1);
	glEnd();

	 glEnable(GL_CULL_FACE);

        glColor4ubv( white );
	glEnable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	DrawImage(1,1,0.0,0.0,1,0.0f,0.0,1,iGlowColor2,-11);

	SetRenderToScreen();

	//glBindTexture(GL_TEXTURE_2D,iGlowColor);
	//glCopyTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, 0, 0, GLOWWTH, GLOWHTH, 0);
}

void CCpGl::PrepairShader(GLuint i)
{

	GLint loc;
	GLenum e;
	GLfloat* vec3;
	char c[5];

	if (  i == -1   )
	{	
		c[0]='i';
		c[1]='f';
		c[2]='t';
		c[3]='x';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[5],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, 1);
		e = glGetError();
		if (e != GL_NO_ERROR)
		{
	//		cout << "bump: "<< gluErrorString(e)<<endl;
		}
		return;
	}
	if (  i == -2   )
	{	
		c[0]='i';
		c[1]='f';
		c[2]='t';
		c[3]='x';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[5],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, 0);
		e = glGetError();
		if (e != GL_NO_ERROR)
		{
	//		cout << "bump: "<< gluErrorString(e)<<endl;
		}
		return;
	}
	

	if (i==-3)
	{
		c[0]='t';
		c[1]='e';
		c[2]='x';
		c[3]='t';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[DEFAULT_SHADER],c);
	//	if (loc==-1)cout<<"text ERROR!!!!!!!\n";
	
		glUniform1i(loc, 0);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "text: "<< gluErrorString(e)<<endl;
		}

		c[0]='b';
		c[1]='u';
		c[2]='m';
		c[3]='p';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[DEFAULT_SHADER],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, 1);
		e = glGetError();
		if (e != GL_NO_ERROR)
		{
	//		cout << "bump: "<< gluErrorString(e)<<endl;
		}
		return;
	}

	
	vector<SGameObject*> obj = GameInterface->GetGameObjects();
	
		c[0]='r';
		c[1]='o';
		c[2]='t';
		c[3]='m';		
		c[4]='\0';


	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) )
	{	
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"rotm ERROR!!!!!!!\n";
	
		GLfloat* mat = new GLfloat[16];

		glMatrixMode(GL_MODELVIEW);
	    glPushMatrix();
	
		glLoadIdentity();
	    glRotatef(-obj[i]->rot.y,0,1,0);
	    glGetFloatv(GL_MODELVIEW_MATRIX,mat);
		glUniformMatrix4fv(loc, 1, GL_FALSE, mat);
		glPopMatrix();
		
		delete mat;
		e = glGetError();
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 )  )
	{
		c[0]='l';
		c[1]='p';
		c[2]='o';
		c[3]='s';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = LX;//10.0;//pLightObjectArray[0].x;
		vec3[1] = 550.0;//pLightObjectArray[0].y;
		vec3[2] = LZ;//10.0;//pLightObjectArray[0].z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}
	}
   
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) 
				|| ( i == -15 ) )
	{	
		c[0]='c';
		c[1]='p';
		c[2]='o';
		c[3]='s';		
		c[4]='\0';
		
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"cpos ERROR!!!!!!!\n";
	
		vec3[0] = sPos.x;
		vec3[1] = sPos.y;
		vec3[2] = sPos.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
	
		if (e != GL_NO_ERROR)
		{
	//		cout << "cpos: "<< gluErrorString(e)<<endl;
		}
    }
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 )  )
	{	
		c[0]='c';
		c[1]='l';
		c[2]='r';
		c[3]='1';		
		c[4]='\0';
		
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"clr1 ERROR!!!!!!!\n";
	
		glUniform4fv(loc, 1, pGraphicObjectArray[obj[i]->iGraphicObjectId].color);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "clr1: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 2 ) )
	{	
		c[0]='d';
		c[1]='e';
		c[2]='p';
		c[3]='t';		
		c[4]='\0';
		
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"clr1 ERROR!!!!!!!\n";
	
		glUniform1i(loc, 1);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "clr1: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) )
	{	
		c[0]='d';
		c[1]='i';
		c[2]='f';
		c[3]='f';		
		c[4]='\0';
		
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"diff ERROR!!!!!!!\n";
			
		glUniform1f(loc, pGraphicObjectArray[obj[i]->iGraphicObjectId].diff);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "diff: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) )
	{	
		c[0]='s';
		c[1]='p';
		c[2]='e';
		c[3]='c';		
		c[4]='\0';
		
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"spec ERROR!!!!!!!\n";
			
		glUniform1f(loc, pGraphicObjectArray[obj[i]->iGraphicObjectId].spec);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
		//	cout << "spec: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) )
	{	
		c[0]='c';
		c[1]='l';
		c[2]='r';
		c[3]='2';		
		c[4]='\0';
		
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"clr2 ERROR!!!!!!!\n";
	
		glUniform4fv(loc, 1, obj[i]->color);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "clr2: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) )
	{	
		c[0]='o';
		c[1]='p';
		c[2]='o';
		c[3]='s';		
		c[4]='\0';
		
		loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"opos ERROR!!!!!!!\n";
	
		float f[4];
		
		f[0] = obj[i]->pos.x;
		f[1] = obj[i]->pos.y;
		f[2] = obj[i]->pos.z;
		f[3] = 0;
		
		glUniform4fv(loc, 1, f);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
		//	cout << pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader << " opos: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == DEFAULT_SHADER ) )
	{	
		c[0]='t';
		c[1]='e';
		c[2]='x';
		c[3]='t';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"text ERROR!!!!!!!\n";
	
		glUniform1i(loc, 0);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "text: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 1 ) )
	{	
		c[0]='l';
		c[1]='m';
		c[2]='a';
		c[3]='p';		
		c[4]='\0';
	
		 loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"text ERROR!!!!!!!\n";

		
		GLint time = GameInterface->GetTime() - obj[i]->iTimer;
		if (GameInterface->GetGameObjects()[i]->iActive)
			time = 10000;
		glUniform1i(loc, time);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
			cout << "time: "<< gluErrorString(e)<<endl;
		}
	}
	if ( ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0 ) || ( pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == DEFAULT_SHADER )  )
	{	
		c[0]='b';
		c[1]='u';
		c[2]='m';
		c[3]='p';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, 1);
		e = glGetError();
		if (e != GL_NO_ERROR)
		{
	//		cout << "bump: "<< gluErrorString(e)<<endl;
		}
	}
	
	if (  pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader == 0   )
	{	
		c[0]='t';
		c[1]='a';
		c[2]='n';
		c[3]='g';		
		c[4]='\0';
		 
	
		 loc = glGetAttribLocation(Shaders[pGraphicObjectArray[obj[i]->iGraphicObjectId].iShader],c);
	//	if (loc==-1)cout<<"tang ERROR!!!!!!!\n";
	
		glBindBuffer(GL_ARRAY_BUFFER, vbos[3]);
		glVertexAttribPointer(loc, 3, GL_FLOAT, GL_FALSE, 0, 0);
		glEnableVertexAttribArrayARB(loc);		
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
		//	cout << "tang: "<< gluErrorString(e)<<endl;
		}
		
	}

		
}

void CCpGl::PrepairShader(char* s, int i)
{

	GLint loc;
	GLenum e;
	GLfloat* vec3;
	char c[5];
	vector<SGameObject*> obj = GameInterface->GetGameObjects();


	if (s=="Shadow")
	 {
		c[0]='t';
		c[1]='y';
		c[2]='p';
		c[3]='e';		
		c[4]='\0';
		 
		int k=0;
	
		if (obj[i]->type == 1)
		{
			k = obj[i]->data[9];
			//k = 1;
		}

		 loc = glGetUniformLocation(Shaders[4],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, k);	
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
			cout << "type: "<< gluErrorString(e)<<endl;
		}
	}else
	if (s=="Color")
	{
		c[0]='c';
		c[1]='l';
		c[2]='r';
		c[3]='1';		
		c[4]='\0';

		 loc = glGetUniformLocation(Shaders[6],c);
	
		glUniform4fv(loc, 1, pGraphicObjectArray[obj[i]->iGraphicObjectId].color);	
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
			cout << "clr1: "<< gluErrorString(e)<<endl;
		}

		c[0]='c';
		c[1]='l';
		c[2]='r';
		c[3]='2';		
		c[4]='\0';

		 loc = glGetUniformLocation(Shaders[6],c);
	
		glUniform4fv(loc, 1, obj[i]->color);	
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
			cout << "clr2: "<< gluErrorString(e)<<endl;
		}
	}else
	if (s=="Splash")
	{
		c[0]='t';
		c[1]='e';
		c[2]='x';
		c[3]='t';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[7],c);
	//	if (loc==-1)cout<<"text ERROR!!!!!!!\n";
	
		glUniform1i(loc, 0);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "text: "<< gluErrorString(e)<<endl;
		}

		c[0]='g';
		c[1]='l';
		c[2]='o';
		c[3]='w';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[7],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, 1);
		e = glGetError();
		if (e != GL_NO_ERROR)
		{
	//		cout << "bump: "<< gluErrorString(e)<<endl;
		}

		c[0]='s';
		c[1]='h';
		c[2]='a';
		c[3]='d';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[7],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, 2);
		e = glGetError();
		if (e != GL_NO_ERROR)
		{
	//		cout << "bump: "<< gluErrorString(e)<<endl;
		}

		c[0]='s';
		c[1]='h';
		c[2]='m';
		c[3]='d';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[7],c);
	//	if (loc==-1)cout<<"bump ERROR!!!!!!!\n";
	
		glUniform1i(loc, shmd);
		e = glGetError();
		if (e != GL_NO_ERROR)
		{
	//		cout << "bump: "<< gluErrorString(e)<<endl;
		}
	}else
	if (  s == "DFail"   )
	{
		c[0]='l';
		c[1]='p';
		c[2]='o';
		c[3]='s';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[14],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = LX;//10.0;//pLightObjectArray[0].x;
		vec3[1] = 550.0;//pLightObjectArray[0].y;
		vec3[2] = LZ;//10.0;//pLightObjectArray[0].z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}


		c[0]='o';
		c[1]='b';
		c[2]='j';
		c[3]='p';		
		c[4]='\0';
		 
                while (glGetError()!=GL_NO_ERROR );
	
		 loc = glGetUniformLocation(Shaders[14],c);
	//	if (loc==-1)cout<<"opos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->pos.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->pos.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->pos.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		

		if (e != GL_NO_ERROR)
		{
			//cout << "opos: "<< gluErrorString(e)<<endl;
		}

		c[0]='o';
		c[1]='b';
		c[2]='r';
		c[3]='t';		
		c[4]='\0';
		 

		 loc = glGetUniformLocation(Shaders[14],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";

		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->rot.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->rot.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->rot.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();

		/*vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->rot.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->rot.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->rot.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();*/
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}

		return;
	}else
	if (  s == "DFailShadowHelp"   )
	{
		c[0]='l';
		c[1]='p';
		c[2]='o';
		c[3]='s';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[15],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = LX;//10.0;//pLightObjectArray[0].x;
		vec3[1] = 550.0;//pLightObjectArray[0].y;
		vec3[2] = LZ;//10.0;//pLightObjectArray[0].z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}

		c[0]='o';
		c[1]='b';
		c[2]='j';
		c[3]='p';		
		c[4]='\0';
		 
                while (glGetError()!=GL_NO_ERROR );
	
		 loc = glGetUniformLocation(Shaders[15],c);
	//	if (loc==-1)cout<<"opos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->pos.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->pos.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->pos.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		

		if (e != GL_NO_ERROR)
		{
		//	cout << "opos: "<< gluErrorString(e)<<endl;
		}

		c[0]='o';
		c[1]='b';
		c[2]='r';
		c[3]='t';		
		c[4]='\0';
		 

		 loc = glGetUniformLocation(Shaders[15],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";

		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->rot.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->rot.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->rot.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}

	}else
	if (  s == "DFailShadowHelp2"   )
	{
		c[0]='l';
		c[1]='p';
		c[2]='o';
		c[3]='s';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[16],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = LX;//10.0;//pLightObjectArray[0].x;
		vec3[1] = 550.0;//pLightObjectArray[0].y;
		vec3[2] = LZ;//10.0;//pLightObjectArray[0].z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}

		c[0]='o';
		c[1]='b';
		c[2]='j';
		c[3]='p';		
		c[4]='\0';
		 
                while (glGetError()!=GL_NO_ERROR );
	
		 loc = glGetUniformLocation(Shaders[16],c);
	//	if (loc==-1)cout<<"opos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->pos.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->pos.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->pos.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		

		if (e != GL_NO_ERROR)
		{
			cout << "opos: "<< gluErrorString(e)<<endl;
		}

		c[0]='o';
		c[1]='b';
		c[2]='r';
		c[3]='t';		
		c[4]='\0';
		 

		 loc = glGetUniformLocation(Shaders[16],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";

		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->rot.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->rot.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->rot.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}

	}else
	if (  s == "DFailShadowHelp3"   )
	{
		c[0]='l';
		c[1]='p';
		c[2]='o';
		c[3]='s';		
		c[4]='\0';
		 
	
		 loc = glGetUniformLocation(Shaders[17],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = LX;//10.0;//pLightObjectArray[0].x;
		vec3[1] = 550.0;//pLightObjectArray[0].y;
		vec3[2] = LZ;//10.0;//pLightObjectArray[0].z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}

		c[0]='o';
		c[1]='b';
		c[2]='j';
		c[3]='p';		
		c[4]='\0';
		 
                while (glGetError()!=GL_NO_ERROR );
	
		 loc = glGetUniformLocation(Shaders[17],c);
	//	if (loc==-1)cout<<"opos ERROR!!!!!!!\n";
	
		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->pos.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->pos.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->pos.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		

		if (e != GL_NO_ERROR)
		{
			cout << "opos: "<< gluErrorString(e)<<endl;
		}

		c[0]='o';
		c[1]='b';
		c[2]='r';
		c[3]='t';		
		c[4]='\0';
		 

		 loc = glGetUniformLocation(Shaders[17],c);
	//	if (loc==-1)cout<<"lpos ERROR!!!!!!!\n";

		vec3 = new GLfloat[3];
		vec3[0] = GameInterface->GetGameObjects()[i]->rot.x;
		vec3[1] = GameInterface->GetGameObjects()[i]->rot.y;
		vec3[2] = GameInterface->GetGameObjects()[i]->rot.z;
		glUniform3fv(loc, 1, vec3);
		e = glGetError();
		
		if (e != GL_NO_ERROR)
		{
	//		cout << "lpos: "<< gluErrorString(e)<<endl;
		}

	}
}


void CCpGl::SetAngles (float a, float b)
{
	ax=a;
	ay=b;
	dx=sin(ay)*cos(ax);
	dy=sin(ax)*cos(ay);
	dz=cos(ay)*cos(ax);
}

void CCpGl::AddToAngles (float a,float b)
{
	//cout << "dx = " << dx <<"; dy = " << dy <<"; dz = " << dz <<endl;
	ax-=a;
	ay-=b;
	if (ax>=90) ax = 89;
	if (ax<=-90) ax = -89;
	
	dz = cosf(ax/180.0f*3.14f)*cosf(ay/180.0f*3.14f);
	dy = sinf(ax/180.0f*3.14f);
	dx = cos(ax/180.0f*3.14f)*sin(ay/180.0f*3.14f);	
	
	
}

void CCpGl::TestDraw()
{
	Clear();
	
	glUseProgramObjectARB ( Shaders [DEFAULT_SHADER] );
 	 PrepairShader( -3 );

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	set_frustum();
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	//glTranslated(-sPos.x,-sPos.y,-sPos.z);
	//glRotatef(ax,1,0,0);
	//glRotated(ay,0,1,0);
	glEnable(GL_COLOR);
	glDisable(GL_TEXTURE_2D);
	
	glBegin( GL_TRIANGLES );
    glColor4ubv( red );
    glVertex3fv( v0 );
    glColor4ubv( green );
    glVertex3fv( v1 );
    glColor4ubv( blue );
    glVertex3fv( v2 );

    glColor4ubv( red );
    glVertex3fv( v0 );
    glColor4ubv( blue );
    glVertex3fv( v2 );
    glColor4ubv( white );
    glVertex3fv( v3 );

    glColor4ubv( green );
    glVertex3fv( v1 );
    glColor4ubv( black );
    glVertex3fv( v5 );
    glColor4ubv( orange );
    glVertex3fv( v6 );

    glColor4ubv( green );
    glVertex3fv( v1 );
    glColor4ubv( orange );
    glVertex3fv( v6 );
    glColor4ubv( blue );
    glVertex3fv( v2 );

    glColor4ubv( black );
    glVertex3fv( v5 );
    glColor4ubv( yellow );
    glVertex3fv( v4 );
    glColor4ubv( purple );
    glVertex3fv( v7 );

    glColor4ubv( black );
    glVertex3fv( v5 );
    glColor4ubv( purple );
    glVertex3fv( v7 );
    glColor4ubv( orange );
    glVertex3fv( v6 );

    glColor4ubv( yellow );
    glVertex3fv( v4 );
    glColor4ubv( red );
    glVertex3fv( v0 );
    glColor4ubv( white );
    glVertex3fv( v3 );

    glColor4ubv( yellow );
    glVertex3fv( v4 );
    glColor4ubv( white );
    glVertex3fv( v3 );
    glColor4ubv( purple );
    glVertex3fv( v7 );

    glColor4ubv( white );
    glVertex3fv( v3 );
    glColor4ubv( blue );
    glVertex3fv( v2 );
    glColor4ubv( orange );
    glVertex3fv( v6 );

    glColor4ubv( white );
    glVertex3fv( v3 );
    glColor4ubv( orange );
    glVertex3fv( v6 );
    glColor4ubv( purple );
    glVertex3fv( v7 );

    glColor4ubv( green );    
 glVertex3fv( v1 );
    glColor4ubv( red );
    glVertex3fv( v0 );
    glColor4ubv( yellow );
    glVertex3fv( v4 );

    glColor4ubv( green );
    glVertex3fv( v1 );
    glColor4ubv( yellow );
    glVertex3fv( v4 );
    glColor4ubv( black );
    glVertex3fv( v5 );

    glEnd( );
 

	float A = 0.055f;
	 float X = 0.0075f;

	int c=0,fcount = GameInterface->GetGameObjects()[1]->data[6];
         float x1=0.20f,x2=0.210f,y1=0.925f-A*3,y2=00.975f-A*3;

	 //fcount = 6543;

	 if ( fcount==0 )        
	 	DrawImage(x1,y1,x2,y2,0.0f,0.0f,70.0f/1024.0f,1.0f,9,1);
	 else 
	 	while (fcount!=0)
		{
			int no = fcount % 10;
			fcount /=10;
			c++;
			DrawImage(x1-c*(x2-x1),y1,x2-c*(x2-x1),y2,0.0f+no*(70.0f/1024.0f),0.0f,70.0f/1024.0f+no*(70.0f/1024.0f),1.0f,9,1);
		}

}


void CCpGl::DrawMenu(int state)
{
        DrawImage(0,0,1,1,0,0,1,1,21,1);

	if ( (state==0) || (state==1) )
	{
		int  x,y;

		SDL_GetMouseState( &x, &y);

		if ( ( 0.4*RESOLUTION_WIDTH <= x ) && ( 0.6*RESOLUTION_WIDTH >= x ) &&
			( 0.4*RESOLUTION_HIGHT >= y ) && ( 0.35*RESOLUTION_HIGHT <= y ) )
			if (state==0)
				DrawImage(0.4,0.6,0.6,0.65,0,0,1,1,23,1);
			else
				DrawImage(0.4,0.6,0.6,0.65,0,0,1,1,24,1);
		else
			DrawImage(0.4,0.6,0.6,0.65,0,0,1,1,22,1);

		if ( ( 0.4*RESOLUTION_WIDTH <= x ) && ( 0.6*RESOLUTION_WIDTH >= x ) &&
			( 0.5*RESOLUTION_HIGHT >= y ) && ( 0.45*RESOLUTION_HIGHT <= y ) )
			if (state==0)
				DrawImage(0.4,0.5,0.6,0.55,0,0,1,1,29,1);
			else
				DrawImage(0.4,0.5,0.6,0.55,0,0,1,1,30,1);
		else
			DrawImage(0.4,0.5,0.6,0.55,0,0,1,1,28,1);

		if ( ( 0.4*RESOLUTION_WIDTH <= x ) && ( 0.6*RESOLUTION_WIDTH >= x ) &&
			( 0.6*RESOLUTION_HIGHT >= y ) && ( 0.55*RESOLUTION_HIGHT <= y ) )
			if (state==0)
				DrawImage(0.4,0.4,0.6,0.45,0,0,1,1,26,1);
			else
				DrawImage(0.4,0.4,0.6,0.45,0,0,1,1,27,1);
		else
			DrawImage(0.4,0.4,0.6,0.45,0,0,1,1,25,1);

//		DrawImage(0.4,0.4,0.6,0.45,0,0,1,1,24,1);
	}
	
	   	if ( ( state==2 ) || (state==3) )
	{
			DrawImage(0.3058,0.0,0.695,0.96,0,0,1,1,31,1);
	}

}

int CCpGl::GetEdges(int i)
{

	SGameObject* o = GameInterface->GetGameObjects()[i];

	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
		set_frustum();

	
	Vector3f v;

	v.x = -o->rot.x/180.0f*3.14f;
	v.y = -o->rot.y/180.0f*3.14f;
	v.z = -o->rot.z/180.0f*3.14f;
	
		 Vector3f sdir(-sinf(v.y/180.0f*3.14f)*cosf(v.x/180.0f*3.14f),
       				sinf(v.x/180.0f*3.14f),
       				-cosf(v.y/180.0f*3.14f)*cosf(v.x/180.0f*3.14f));
	


		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  pGraphicObjectArray[ o->iGraphicObjectId ].iIndexBufferId);

	SGraphicObject* g = &pGraphicObjectArray[o->iGraphicObjectId];



	IdentityAll();
	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();		
	    glViewport(0,0,RESOLUTION_WIDTH,RESOLUTION_HIGHT);
		set_frustum();

	
	glMatrixMode(GL_MODELVIEW);
		glLoadIdentity();
		
		gluLookAt(0,0,0,dx,dy,dz,0,1,0);

	glTranslatef(-sPos.x,
		     -sPos.y,
		     -sPos.z);


	glDisable(GL_DEPTH_TEST);


	Vector4f* front;
	Vector4f* back;

	front = new Vector4f[20000];
	back = new Vector4f[20000];
	int fsize, bsize;

	fsize=bsize=0;

	float cy = cos(v.y);
	float sy = sin(v.y);


	for (k=0;k<g->edges.size();k++)
	{


	    float dir1,dir2;

//----------------------------------------
	   Vector3f p1 = Vector3f ( 	pVertexArray[g->edges[k].v1[0]].x,
							pVertexArray[g->edges[k].v1[0]].y,
							pVertexArray[g->edges[k].v1[0]].z);

		p1= Vector3f(	p1.x*cy-p1.z*sy,
					p1.y,
					p1.x*sy+p1.z*cy);

		p1 = Vector3f ( 	p1.x+o->pos.x,
						p1.y+o->pos.y,
						p1.z+o->pos.z	);

		Vector3f p2 = Vector3f ( 	pVertexArray[g->edges[k].v1[1]].x,
							pVertexArray[g->edges[k].v1[1]].y,
							pVertexArray[g->edges[k].v1[1]].z	);

		p2= Vector3f(	p2.x*cy-p2.z*sy,
					p2.y,
					p2.x*sy+p2.z*cy);

		p2 = Vector3f ( 	p2.x+o->pos.x,
						p2.y+o->pos.y,
						p2.z+o->pos.z	);

		Vector3f p3 = Vector3f ( 	pVertexArray[g->edges[k].v1[2]].x,
							pVertexArray[g->edges[k].v1[2]].y,
							pVertexArray[g->edges[k].v1[2]].z	);

		
		p3= Vector3f(	p3.x*cy-p3.z*sy,
					p3.y,
					p3.x*sy+p3.z*cy);

		p3 = Vector3f ( 	p3.x+o->pos.x,
						p3.y+o->pos.y,
						p3.z+o->pos.z	);

		dir1 = (p3-p2).CrossProduct( p2-p1 ).DotProduct(p2-Vector3f(LX,550,LZ));
	   
//---------------------------------

		Vector3f r1 = Vector3f ( 	pVertexArray[g->edges[k].v2[0]].x,
							pVertexArray[g->edges[k].v2[0]].y,
							pVertexArray[g->edges[k].v2[0]].z);

		r1= Vector3f(	r1.x*cy-r1.z*sy,
					r1.y,
					r1.x*sy+r1.z*cy); 

		r1 = Vector3f ( 		r1.x+o->pos.x,
						r1.y+o->pos.y,
						r1.z+o->pos.z	);

		Vector3f r2 = Vector3f ( 	pVertexArray[g->edges[k].v2[1]].x,
							pVertexArray[g->edges[k].v2[1]].y,
							pVertexArray[g->edges[k].v2[1]].z	);

		r2= Vector3f(	r2.x*cy-r2.z*sy,
					r2.y,
					r2.x*sy+r2.z*cy);

		r2 = Vector3f ( 		r2.x+o->pos.x,
						r2.y+o->pos.y,
						r2.z+o->pos.z	);

		Vector3f r3 = Vector3f ( 	pVertexArray[g->edges[k].v2[2]].x,
							pVertexArray[g->edges[k].v2[2]].y,
							pVertexArray[g->edges[k].v2[2]].z	);

		
		r3= Vector3f(	r3.x*cos(v.y)-r3.z*sin(v.y),
					r3.y,
					r3.x*sin(v.y)+r3.z*cos(v.y));

		r3 = Vector3f (	 	r3.x+o->pos.x,
						r3.y+o->pos.y,
						r3.z+o->pos.z	);

		dir2 = (r3-r2).CrossProduct( r2-r1 ).DotProduct(r2-Vector3f(LX,550,LZ));

//---------------------------------


			Vector3f L = Vector3f(LX,550,LZ);
			r1 = p2;
			r2 = p1;

		glLineWidth(5);

			glActiveTextureARB(GL_TEXTURE0_ARB);
			glBindTexture(GL_TEXTURE_2D,  depth2);

			glUseProgramObjectARB ( Shaders [ 12*0+6 ] );

			PrepairShader( -3 );
	

int K = 1; 

		if (dir1*dir2 < 0)
		{

			glUseProgramObjectARB ( Shaders [ 12 ] );

			if (dir1>0)
			{

				front[fsize++]=Vector4f(p2.x,p2.y,p2.z,1);
				front[fsize++]=Vector4f(p1.x,p1.y,p1.z,1);
				front[fsize++]=Vector4f(p1.x*(K)-L.x*K,p1.y*(K)-L.y*K,p1.z*(K)-L.z*K,0);
				front[fsize++]=Vector4f(p2.x*(K)-L.x*K,p2.y*(K)-L.y*K,p2.z*(K)-L.z*K,0);

			}else
			{

				front[fsize++]=Vector4f(r2.x,r2.y,r2.z,1);
				front[fsize++]=Vector4f(r1.x,r1.y,r1.z,1);
				front[fsize++]=Vector4f(r1.x*(K)-L.x*K,r1.y*(K)-L.y*K,r1.z*(K)-L.z*K,0);
				front[fsize++]=Vector4f(r2.x*(K)-L.x*K,r2.y*(K)-L.y*K,r2.z*(K)-L.z*K,0);

			}

			glUseProgramObjectARB ( Shaders [ 13 ] );
			if (dir1>0)
			{
				back[bsize++]=Vector4f(p2.x,p2.y,p2.z,1);
				back[bsize++]=Vector4f(p1.x,p1.y,p1.z,1);
				back[bsize++]=Vector4f(p1.x*(K)-L.x*K,p1.y*(K)-L.y*K,p1.z*(K)-L.z*K,0);
				back[bsize++]=Vector4f(p2.x*(K)-L.x*K,p2.y*(K)-L.y*K,p2.z*(K)-L.z*K,0);
			}else
			{
				back[bsize++]=Vector4f(r2.x,r2.y,r2.z,1);
				back[bsize++]=Vector4f(r1.x,r1.y,r1.z,1);
				back[bsize++]=Vector4f(r1.x*(K)-L.x*K,r1.y*(K)-L.y*K,r1.z*(K)-L.z*K,0);
				back[bsize++]=Vector4f(r2.x*(K)-L.x*K,r2.y*(K)-L.y*K,r2.z*(K)-L.z*K,0);
			}


		}


	}


	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
 	glDisableClientState(GL_NORMAL_ARRAY);
 	glDisableClientState(GL_COLOR_ARRAY);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, 0);
	glBindBuffer(GL_ARRAY_BUFFER, 0);

	glUseProgramObjectARB ( Shaders [ 12 ] );
		glFrontFace(GL_CCW);

		glVertexPointer(4, GL_FLOAT, 0,front);
   		glDrawArrays(GL_QUADS, 0, fsize);

	glUseProgramObjectARB ( Shaders [ 13 ] );
		glFrontFace(GL_CW);

		glVertexPointer(4, GL_FLOAT, 0,back);
   		glDrawArrays(GL_QUADS, 0, bsize);

	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
 	glEnableClientState(GL_NORMAL_ARRAY);

	glBindBuffer(GL_ARRAY_BUFFER, vbos[0]);
	glVertexPointer( 3,GL_FLOAT,0,0);



	glEnable(GL_CULL_FACE);
	glFrontFace(GL_CW);

	glUseProgramObjectARB ( Shaders [14] ); 	
	PrepairShader( "DFail",i );
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  g->iIndexBufferId);
		glDrawElements( GL_TRIANGLES, g->iIndexCount,
						GL_UNSIGNED_INT,
						NULL );

	

	glUseProgramObjectARB ( Shaders [15] ); 	
	PrepairShader( "DFailShadowHelp",i );
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  g->iIndexBufferId);
		glDrawElements( GL_TRIANGLES, g->iIndexCount,
						GL_UNSIGNED_INT,
						NULL );

	glFrontFace(GL_CCW);

	glUseProgramObjectARB ( Shaders [16] ); 	
	PrepairShader( "DFailShadowHelp2",i );
		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  g->iIndexBufferId);
		glDrawElements( GL_TRIANGLES, g->iIndexCount,
						GL_UNSIGNED_INT,
						NULL );

	glFrontFace(GL_CCW);


	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER,  0);

	delete (front);
	delete (back);

}

int  get_edges(void* cpgl)
{
	((CCpGl*)cpgl)->GetEdges(((CCpGl*)cpgl)->cntr);
}

