#include <CpSDL.h>
#include <iostream>
#include <CpSockets.h>
#include <GL/gl.h>
using namespace std;


#define MOVING_SPEED 0.1
#define ROTATING_SPEED 0.075



set::set()
{
		for (int i=0;i<MAX_EVENTS;i++)
			events[i]=NULL;
}

int set::add(SDL_Event* e)
{

		for (int i=0;i<MAX_EVENTS;i++)
			if (events[i]==NULL)
			{
				events[i] = new SDL_Event;
				memcpy(events[i],e,sizeof(SDL_Event));
				return 1;
			}
		return 0;
		cout << "Error: too many events\n";
}

void set::remove(SDL_Event e)
{

		for (int i=0;i<MAX_EVENTS;i++)
			if (events[i]!=NULL)
			if (events[i]->type==SDL_KEYDOWN)
				if (events[i]->key.keysym.sym == e.key.keysym.sym)
			{
				delete events[i];
				events[i] =NULL;
				return;
			}
		cout << "Error: deleting an unexisting element\n";
}

Uint8 *keystate;
CCpSDL::CCpSDL(char name[],char icon[])
{
	SDL_Init( SDL_INIT_VIDEO | SDL_INIT_JOYSTICK | SDL_INIT_TIMER);
	
	SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
	SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 4);

	SDL_WM_SetCaption(name,icon);
	SDL_SetVideoMode(RESOLUTION_WIDTH, RESOLUTION_HIGHT, 8, SDL_OPENGL);	
	SDL_ShowCursor(1);
	SDL_WM_GrabInput(SDL_GRAB_OFF);
	cout << "Init: SDL\n";
	Time = SDL_GetTicks();
	TimeSync = 0;
	keystate = SDL_GetKeyState(NULL);
}

void CCpSDL::CheckMenuInput()
{
	SDL_Event event;//NULL;
   //event=new SDL_Event;

	int x,y;
	SDL_GetMouseState( &x, &y);
	
	SDL_PumpEvents();

	Uint32 t = SDL_GetTicks()-Time;
	

	while (SDL_PollEvent(&event))
   {
	
	 if ( event.type == SDL_QUIT )
	  	GameInterface->ShutDown();
	
	 if ( event.type == SDL_MOUSEBUTTONDOWN )
		if (event.button.button == SDL_BUTTON_LEFT)
		{
	 	 	GameInterface->GameState++;
		}

	if ( event.type == SDL_MOUSEBUTTONUP )
		if (event.button.button == SDL_BUTTON_LEFT)
		{
			if ( ( 0.4*RESOLUTION_WIDTH <= x ) && ( 0.6*RESOLUTION_WIDTH >= x ) &&
				( 0.4*RESOLUTION_HIGHT >= y ) && ( 0.35*RESOLUTION_HIGHT <= y ) )
			{
				if (GameInterface->GameState==1)
				{
					GameInterface->GameState=-1;
					SDL_ShowCursor(0);
				}
			}else
			if ( ( 0.4*RESOLUTION_WIDTH <= x ) && ( 0.6*RESOLUTION_WIDTH >= x ) &&
				( 0.6*RESOLUTION_HIGHT >= y ) && ( 0.55*RESOLUTION_HIGHT <= y ) )
			{
				if (GameInterface->GameState==1)
				{
					GameInterface->GameState=2;
				}
			}else
			if ( ( 0.4*RESOLUTION_WIDTH <= x ) && ( 0.6*RESOLUTION_WIDTH >= x ) &&
				( 0.5*RESOLUTION_HIGHT >= y ) && ( 0.45*RESOLUTION_HIGHT <= y ) )
			{
				if (GameInterface->GameState==1)
				{
					GameInterface->ShutDown();
				}
			}	
			else
	 	 	GameInterface->GameState--;
		}

	if ( event.type == SDL_KEYDOWN )
		{
			if (event.key.keysym.sym == SDLK_SPACE)
				{
					GameInterface->GameState=-1;
					SDL_ShowCursor(0);
				}

  		

	if ( event.key.keysym.sym == SDLK_ESCAPE )
		{
			if ( (GameInterface->GameState<2) && (GameInterface->GameState>=0) )
			    GameInterface->ShutDown();
			else
			   GameInterface->GameState=0;
		}

		}

	}	 
							 			 
		/* if ( keystate[SDLK_ESCAPE] )
		{
			if (GameInterface->GameState<2)
			    GameInterface->ShutDown();
			else
			   GameInterface->GameState=0;
		}*/
		  			  		  

}

int bl = 1;

void CCpSDL::CheckInput()
{
   SDL_Event event;//NULL;
   //event=new SDL_Event;

	
	
	SDL_PumpEvents();

	Uint32 t = SDL_GetTicks()-Time;
	

	while (SDL_PollEvent(&event))
   {
	
	 if ( event.type == SDL_QUIT )
	  	GameInterface->ShutDown();
	
	 if ( event.type == SDL_MOUSEMOTION )
	 	 GraphicInterface->AddToAngles( event.motion.yrel*ROTATING_SPEED*t, event.motion.xrel*ROTATING_SPEED*t ); 

	//event=new SDL_Event;	

	if ( event.type == SDL_KEYDOWN )
		{
		if (event.key.keysym.sym == SDLK_p)
			{
				 SGameMsg msg;
				 msg.type = GMSG_MUSIC_TOGGLE;
				 msg.TimeStemp = GetTime();	

				GameInterface->AddMsg(msg);
			}

		if (event.key.keysym.sym == SDLK_F3)
			{             
                    GraphicInterface->wf = !GraphicInterface->wf;
                    cout << "Switching glPolyMode" <<endl;
			}
			
		if (event.key.keysym.sym == SDLK_F1)
			{
			     cout << "Help:\nF1 - show this menu\nF2 - show frame rate\nF3 - Toggle Blending\nF4 - Toggle show shadow geometry\nF5 Toggle MipMaps ON/OFF\nF6 Toggle Texture Mag Filter\nF7 Toggle Frustum Culling\nF8 Toggle Blending\nF9 ToggleShadows" <<endl;
			}
			
			
		if (event.key.keysym.sym == SDLK_F2)
			{
			    if (GameInterface->fr)
			    GameInterface->fr = 0;
			    else
				GameInterface->fr = -1;
				
				 cout << "Switching Show_Framerate" <<endl;
			}
			
		if (event.key.keysym.sym == SDLK_F7)
			{	
			   GraphicInterface->fc = !GraphicInterface->fc;
			   
			   cout << "Switching Frustrum Culling" <<endl;
            }	
		if (event.key.keysym.sym == SDLK_F8)
			{	
			   if (bl)
			   glDisable (GL_BLEND);
			   else
			   glEnable (GL_BLEND);
			   bl = !bl;
			   
			   cout << "Switching GL_BLEND\n \tNote that this also affect the blending used for shadows" <<endl;
            }
			
		if (event.key.keysym.sym == SDLK_f)
			{
				 SGameMsg msg;
				 msg.type = GMSG_TELEPORT;
				 msg.TimeStemp = GetTime();
				 msg.target=1;
			}

		if (event.key.keysym.sym == SDLK_F4)
			{
				 GraphicInterface->shmd = !GraphicInterface->shmd;
			}

        if (event.key.keysym.sym == SDLK_F5)
			{
                 GraphicInterface->mm = !GraphicInterface->mm;
				 GraphicInterface->LoadTextures("textures.lof");
				 cout << "MipMaps on/off" <<endl;
			}

        if (event.key.keysym.sym == SDLK_F6)
			{
                 GraphicInterface->tq = !GraphicInterface->tq;
				 GraphicInterface->LoadTextures("textures.lof");
				 cout << "Texture MAG filter NEAREST/LINEAR" <<endl;
			}
			
        if (event.key.keysym.sym == SDLK_F9)
			{
                 GraphicInterface->sh = !GraphicInterface->sh;
				 cout << "Toggling shadows on/off" <<endl;
			}


		if (event.key.keysym.sym == SDLK_r)
			{
				 SGameMsg msg;
				 msg.type = GMSG_DEATH;
				 msg.TimeStemp = GetTime();
				 msg.target=1;
				GameInterface->AddMsg(msg);
			}

			if ( event.key.keysym.sym == SDLK_ESCAPE )
			{
			   		GameInterface->GameState=0;
					SDL_ShowCursor(1);
			}

		}
   }

	
	/* for (int i = 0; i< MAX_EVENTS;i++)
		 if (events.events[i]!=NULL)
		 if (events.events[i]->type == SDL_KEYDOWN)*/
		 {
							 			 

				
			  if ( keystate[SDLK_LEFT] )
				if (keystate[SDLK_LSHIFT])
				  GraphicInterface->AddToPos( GraphicInterface->GetDirection().CrossProduct(
											   Vector3f( 0.0, -1.0, 0.0 ) ).Rescale( MOVING_SPEED/30.0*t ) );
				else
				  GraphicInterface->AddToPos( GraphicInterface->GetDirection().CrossProduct(
											   Vector3f( 0.0, -1.0, 0.0 ) ).Rescale( MOVING_SPEED*t ) );
			  if ( keystate[SDLK_RIGHT] )
				if (keystate[SDLK_LSHIFT])
				  GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection().CrossProduct(
											  Vector3f(0.0,1.0,0.0) ).Rescale( MOVING_SPEED/30.0*t ) );
				else
				  GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection().CrossProduct(
											  Vector3f(0.0,1.0,0.0) ).Rescale( MOVING_SPEED*t ) );
			  
			  if ( keystate[SDLK_UP] )
				if (keystate[SDLK_LSHIFT])
				  GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection()*( MOVING_SPEED/30.0*t ) );
				else
				if (keystate[SDLK_RSHIFT])
				  GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection()*( MOVING_SPEED*30.0*t ) );
				else
				   GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection()*( MOVING_SPEED*t ) );
			  if ( keystate[SDLK_DOWN] )
				if (keystate[SDLK_LSHIFT])
				  GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection()*( (-MOVING_SPEED/30.0)*t ) );
				else
				if (keystate[SDLK_RSHIFT])
				  GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection()*( (-MOVING_SPEED*30.0)*t ) );
				else
			  	  GraphicInterface->AddToPos( GraphicInterface->
			  									GetDirection()*( (-MOVING_SPEED)*t ) );
			  
			  if ( keystate[SDLK_w] )
			  {
				  

				SGameMsg msg;
				msg.type = GMSG_ACCELERATE;
				msg.target = 1;
				msg.size = 1;
				msg.data = new float[1];
				msg.data[0] = 0.011*t;
				msg.TimeStemp = GetTime();

				GameInterface->AddMsg(msg);
 
			  }
			  if ( keystate[SDLK_s] )
			  {
				  

				SGameMsg msg;
				msg.type = GMSG_ACCELERATE;
				msg.target = 1;
				msg.size = 1;
				msg.data = new float[1];
				msg.data[0] = -0.011*t;
				msg.TimeStemp = GetTime();

				GameInterface->AddMsg(msg);
				
 
			  }
			  
			  if ( keystate[SDLK_a] )
			  {
				  
				Vector3f rot = GameInterface->GetGameObjects()[1]->rot;
				  
				float s = GameInterface->GetGameObjects()[1]->data[1];
				  
				SGameMsg msg;
				msg.type = GMSG_CHANGE_ANGLES;
				msg.target = 1;
				msg.size = 2;
				msg.data = new float[2];
				msg.data[0] = rot.x;
				msg.data[1] = rot.y+s*t;
				msg.TimeStemp = GetTime();
				CPSocketSend(&msg);
				GameInterface->AddMsg(msg);
 
			  }
			  if ( keystate[SDLK_d] )
			  {
				  
				Vector3f rot = GameInterface->GetGameObjects()[1]->rot;
				  
				float s = GameInterface->GetGameObjects()[1]->data[1];
				  
				SGameMsg msg;
				msg.type = GMSG_CHANGE_ANGLES;
				msg.target = 1;
				msg.size = 2;
				msg.data = new float[2];
				msg.data[0] = rot.x;
				msg.data[1] = rot.y-s*t;
				msg.TimeStemp = GetTime();
				CPSocketSend(&msg);
				GameInterface->AddMsg(msg);
 
			  }
			  if ( keystate[SDLK_SPACE] )
			  {
				
					Vector3f rot = GameInterface->GetGameObjects()[1]->rot;
					Vector3f pos = GameInterface->GetGameObjects()[1]->pos; 
								  
					SGameMsg msg;
					msg.type = GMSG_SHOOT;
					msg.target = 1;
					msg.size = 6;
					msg.data = new float[msg.size];
					msg.data[0] = pos.x;
					msg.data[1] = pos.y;
					msg.data[2] = pos.z;
					msg.data[3] = rot.x;
					msg.data[4] = rot.y;
					msg.data[5] = rot.z;
					msg.TimeStemp = GetTime();
				    CPSocketSend(&msg);
				    GameInterface->AddMsg(msg);
					
				
 
			  }
			 if ( keystate[SDLK_z] )
			  {
				
					Vector3f rot = GameInterface->GetGameObjects()[1]->rot;
					Vector3f pos = GameInterface->GetGameObjects()[1]->pos; 
								  
					SGameMsg msg;
					msg.type = 216;
					msg.target = 1;
					msg.TimeStemp = GetTime();
					//cout << GetTime()<< endl;
					
					if (GetTime()%1000<10) PrintConnections();

					GameInterface->AddMsg(msg);
					CPSocketSend(&msg);
				
 
			  }
			 if ( keystate[SDLK_q] )
			  {
				 //add_lag();
			  }
			 if ( keystate[SDLK_e] )
			  {
				 //remove_lag();
			  }

			 if ( keystate[SDLK_j] )
			  {
				 GraphicInterface->LX+=1.0*t;
			  }
			 if ( keystate[SDLK_l] )
			  {
				 GraphicInterface->LX-=1.0*t;
			  }
			  if ( keystate[SDLK_i] )
			  {
				 GraphicInterface->LZ+=1.0*t;
			  }
			 if ( keystate[SDLK_k] )
			  {
				 GraphicInterface->LZ-=1.0*t;
			  }

			
			//events.remove(*events.events[i]);
		  			  		  
		  }
		  Time = SDL_GetTicks();

	 
}

void CCpSDL :: EndCyrcle()
{
	SDL_GL_SwapBuffers( );
	
}
