#include <CpSound.h>


CCpSound :: CCpSound()
{

		SDL_Init(SDL_INIT_AUDIO);

		Mix_OpenAudio(MIX_DEFAULT_FREQUENCY,
			  MIX_DEFAULT_FORMAT,
			  MIX_DEFAULT_CHANNELS,
			  4096);

		Mix_AllocateChannels(16);

		bMusicOn = false;
                bSoundOn = true;
		cout << "Init: CpSound" << endl;
}

void CCpSound :: LoadSounds(char* c)
{
	cout << "Loading Sounds" << endl;

	FILE* f;
	f = fopen(c,"rw");

	int n;
	fscanf(f,"%d",&n);
	
	char s[100];

	if (n>0)
	{
		fscanf(f,"%s",&s);
		LoadMusic(s);
	}

	for (int i=1;i<n;i++)
	{
		fscanf(f,"%s",&s);
		LoadSound(s);
	}

	cout << "   Sounds Loaded" << endl;
}
/*
void CCpSound :: LoadMusic(char* c)
{
	cout << "   Loading Music" << endl;
	cout << "      Loading " << c << endl;

	//c= "/home/jonathan_targaryen/Darth_Nerdius/music/Sabaton/Primo Victoria/03 Panzer Battalion.mp3";

		SMPEG_Info info;
			music = SMPEG_new(c, &info, 0);

		if (SMPEG_error(music)!=NULL) cout << "Cannot load" << c <<endl;

			//assert(mpeg);
			//assert(info.has_audio);

			// Tell SMPEG what the audio format is.
			{
				SDL_AudioSpec audioFmt;
				int			  frequency, channels;
				Uint16		  format;
				Mix_QuerySpec(&frequency, &format, &channels);
				audioFmt.format   = format;
				audioFmt.freq     = frequency;
				audioFmt.channels = channels;

				SMPEG_actualSpec(music, &audioFmt);
			}

			// Hook in the MPEG music mixer.
			//Mix_HookMusic(SMPEG_playAudioSDL, mpeg);
			SMPEG_enableaudio(music, 1);
			SMPEG_enablevideo(music, 0);
			SMPEG_loop(music, true );


	cout << "         Loaded " << c << endl;
}*/

void CCpSound :: LoadSound(char* c)
{
	cout << "   Loading Sounds" << endl;
	cout << "      Loading " << c << endl;
	pSoundArray.push_back(Mix_LoadWAV_RW(SDL_RWFromFile(c, "rb"), 1));
	cout << "         Loaded " << c << endl;
}
/*
void CCpSound :: PlayMusic()
{
	Mix_HookMusic(SMPEG_playAudioSDL, music);
	SMPEG_play(music);
	bMusicOn = true;
}

void CCpSound :: StopMusic()
{
	Mix_HookMusic(NULL,NULL);
	bMusicOn = false;
}
*/
void CCpSound :: PlaySound(int i, int v)
{
        if (bSoundOn)
	Mix_PlayChannel(-1,pSoundArray[i],0);
}
