 varying vec4 pos;
 varying vec4 rpos;
 varying vec4 tpos;
 varying vec3 normal;
 
 uniform mat4 view;
 uniform mat4 proj;
 
 
vec4 toScreenCoords( in vec4 vertex, in mat4 modelViewProjection )
{

        vec4 tmp = modelViewProjection * vertex;
	
        return tmp;

}

void main()

{

        pos = gl_Vertex;
	normal = gl_Normal;
	rpos = gl_ModelViewMatrix * pos;
        tpos = toScreenCoords( pos, proj*view );

	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
	gl_TexCoord[0] = gl_MultiTexCoord0;

}